import 'package:flutter/widgets.dart';
import 'package:flutter_local_notifications/flutter_local_notifications.dart';
import 'package:rapidfire/Api.dart';
import 'package:rapidfire/Config.dart';
import 'package:workmanager/workmanager.dart';
import 'BGHelperDB.dart';
import 'Db.dart';

class ServiceRF {
  static runSyncService(IConfigRF config, Db db) {
    // Api().runSyncService(config, db);
  }
}

final dbHelper = BGHelperDB.instance;

startService(
    String jobName, Function callback, Map<String, dynamic> inputData) async {
  WidgetsFlutterBinding.ensureInitialized();
  await Workmanager.initialize(callback, isInDebugMode: false);
  await Workmanager.registerOneOffTask("1", jobName, inputData: inputData);
}

// make 0 Config Table service
resetServiceSync(String serviceName) async {
  await dbHelper.deleteService(serviceName); // can be read
  Map<String, dynamic> row = {
    BGHelperDB.jobName: '$serviceName',
    BGHelperDB.jobCompleteStatus: 0,
    BGHelperDB.remarks: ''
  };
  await dbHelper.insert(row);
  await dbHelper.updateCompleteStatus(serviceName, 0);
}

resetServiceFetch(String serviceName) async {
  await dbHelper.deleteService(serviceName); // can be read
  Map<String, dynamic> row = {
    BGHelperDB.jobName: '$serviceName',
    BGHelperDB.jobCompleteStatus: 0,
    BGHelperDB.remarks: ""
  };
  await dbHelper.insert(row);
  await dbHelper.updateCompleteStatus(serviceName, 0);
}

/*updateServiceFetch(String serviceName, String modelName) async {
  await dbHelper.deleteService(serviceName); // can be read
  Map<String, dynamic> row = {
    BGHelperDB.jobName: '$serviceName',
    BGHelperDB.jobCompleteStatus: 0,
    BGHelperDB.remarks: modelName
  };

  await dbHelper.updateFetchTable(serviceName, modelName);
}*/

// read CompleteStatus value from Config Table
watchServiceCompleted(String serviceName) async {
  var ret = await dbHelper
      .get('select * from Config where JobName = ?', [serviceName]);
  //return ret.first['CompleteStatus'];
  return ret;
} // read CompleteStatus value from Config Table

watchFetchCompleted(String serviceName) async {
  var currentModel = await dbHelper
      .get('select * from Config where JobName = ?', [serviceName]);

  if (currentModel != null) {
    var ret = await dbHelper.get(
        'select * from FetchHistory where (Success = 1 or Success = 4) and TableName = ?',
        [currentModel.first["Remarks"]]);
    if (ret != null && ret.length != 0) {
      await dbHelper.updateFetchHistory(currentModel.first["Remarks"]);
    }
    return ret;
  } else
    return null;
}

// only service can update DB
notifyServiceCompleted(String serviceName) async {
  await dbHelper.updateCompleteStatus(serviceName, 1);
  //notify('Server Data Operation Status:', 'Sync data has been successfully completed!');
}

//updateFetchHistory(int userID, String tableName, int pageNo, int isFetched) async {
//  var ret =
//      await dbHelper.get('select * from FetchHistory where TableName=? and PageNo=?', [tableName, pageNo]);
//  if (ret.length == 0)
//    dbHelper.insertFetchHistory(userID, tableName, pageNo, isFetched);
//  else
//    dbHelper.updateFetchHistory(userID, tableName, pageNo, isFetched);
//}

isAlreadyFetched(String tableName, int pageNo) async {
  bool isFetched = false;
  var ret = await dbHelper.get(
      'select * from FetchHistory where TableName=? and PageNo=?',
      [tableName, pageNo]);
  if (ret.length > 0) {
    if (ret.first['IsFetched'] == 1) isFetched = true;
  }
  return isFetched;
}

notify(String title, String description) async {
  FlutterLocalNotificationsPlugin flp = FlutterLocalNotificationsPlugin();
  var android = AndroidInitializationSettings('@mipmap/ic_launcher');
  var iOS = IOSInitializationSettings();
  var initSettings = InitializationSettings(android: android, iOS: iOS);
  flp.initialize(initSettings);
  var androidDetails = AndroidNotificationDetails(
      'channel id', 'channel NAME', 'CHANNEL DESCRIPTION',
      priority: Priority.high, importance: Importance.max);
  var iOSDetails = IOSNotificationDetails();
  var platform = NotificationDetails(android: androidDetails, iOS: iOSDetails);
  await flp.show(0, title, description, platform, payload: 'description');
}
