import 'package:reflectable/mirrors.dart';

import 'Annotation.dart';
import 'Config.dart';
import 'Db.dart';
import 'GlobalScopeRF.dart';
import 'Annotation.dart' as annotation;
import 'dart:io';

class Dynamic {
  Object clazz = null;

  Dynamic([Object object]) {
    clazz = object;
  }

  setObject(Object object) {
    clazz = object;
  }

  Object create(String className) {} //BAD

  dynamic newClass() => classMirror.newInstance("", []);

  Object invoke(String methodName, String pram) =>
      instanceMirror.invoke(methodName, ["Imrose"]); //BAD

  get hasBaseModel {
    try {
      var hasBase = true;
      var ret = classMirror.superclass?.declarations?.values;
      if (ret == null) hasBase = false;
      return hasBase;
    } catch (e) {
      return false;
    }
  }

  set(String name, Object value) {
    VariableMirror field;

    try {
      var childClass =
          classMirror.declarations.values.where((e) => e.simpleName == name).toList().first;
      field = childClass;
    } catch (e) {
      var baseList =
          classMirror.superclass.declarations.values.where((e) => e.simpleName == name).toList();
      var baseClass = baseList.first;
      field = baseClass;
    }

    dynamic dVal = convertType(field.reflectedType, value);
    instanceMirror.invokeSetter(name, dVal);
  }

  Object get(String name) => instanceMirror.invokeGetter(name); //GET

  ClassMirror get classMirror {
    var ret;
    if (clazz is Type)
      ret = Model.reflectType(clazz);
    else
      ret = Model.reflectType(clazz.runtimeType);
    return ret;
  }

  InstanceMirror get instanceMirror => Model.reflect(clazz);

  dynamic convertType(Type type, Object value) {
    if (value == null) return null;
    if (type.toString().contains('String')) {
      return value.toString();
    } else if (type.toString().contains('double')) {
      return double.parse(value.toString().trim());
    } else if (type.toString().contains("byte[]")) {
      return null;
    } else if (type.toString().contains('int')) {
      return int.parse(value.toString().trim());
    } else if (type.toString().contains('bool')) {
      if (value is int)
        (value == 0) ? false : true;
      else
        return value;
    } else
      return value;
  }

  Map<String, dynamic> modelToDataMap() {
    // for save + get model json string
    Map<String, dynamic> modelData = {};
//    for (var v in classMirror.declarations.values) {
//      if (v is VariableMirror) {
//        modelData[v.simpleName] = get(v.simpleName);
//      }
//    }

    modelMembers.forEach((name, dynamic type) {
      if (!type.toString().contains('List<')) {
        modelData[name] = get(name);
      }
    });

    return modelData;
  }

  void dataMapToModel(Map<String, dynamic> json) {
    modelMembers.forEach((name, dynamic type) {
      if (!type.toString().contains('List<')) {
        if (name.toLowerCase().contains('date')) {
          if (json[name] != null) set(name, json[name].split("T00").first);
        } else
          set(name, json[name]);
      }
    });
  }

  Object dataMapToNewModel(Map<String, dynamic> modelMap) {
    var newModel;
    Map<dynamic, dynamic> newModelMap = modelMap;
    ModelRF mrf = Libs.appModels.get()[clazz.runtimeType.toString()];
    newModel = Dynamic(mrf.model).newClass();
    newModelMap.forEach((key, value) {
      if (value is Map) {
        var model = Models.models[key].model;
        setObject(model);
        var x = dataMapToNewModel(value);
        Dynamic(newModel).set(key, x);
      } else
        Dynamic(newModel).set(key, value);
    });
    return newModel;
  }

  modelMembers1() {
    return null;
  }

  Map<String, Object> get modelMembers {
    Map<String, Object> data = Map();
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        data[v.simpleName] = v.reflectedType;
      }
    }

    try {
      classMirror.superclass.instanceMembers.forEach((_, value) {
        if (value.runtimeType.toString().contains('ImplicitGetterMirrorImpl')) {
          data[value.simpleName] = value.dynamicReflectedReturnType;
        }
      });
    } catch (e) {}

    return data;
  }

  List<String> get childModels {
    List<String> data = List();
    modelMembers.forEach((name, dynamic type) {
      if (type.toString().contains('List<')) {
        data.add(name);
      }
    });

    return data;
  }

  List<Map> annotationData(Type annotationName) {
    //var dataList = {};
    List<Map> checkList = List();

    //Class Header
    classMirror.metadata.forEach((metadata) {
      if (metadata.runtimeType == annotationName) {
        print(get(metadata.runtimeType.toString()));
      }
    });

    //Variable Header
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        if (v.metadata.isNotEmpty) {
          if (v.metadata.first.runtimeType == annotationName) {
            var annotationData = {};
            var data = {};
            data["field"] = v.simpleName;
            data["type"] = v.reflectedType;
            Object tmp = clazz;
            clazz = v.metadata.first;
            for (var av in classMirror.declarations.values) {
              if (av is VariableMirror) {
                annotationData[av.simpleName] = get(av.simpleName);
              }
            }
            data["data"] = annotationData;
            clazz = tmp;
            //dataList.addAll(data);
            checkList.add(data);
          }
        }
      }
    }

//          for (int i = 0; i < fields.length; i++) {
//            annotationData[fields[i]] = getter(fields[i]);
//          }

//    for (var v in classMirror.declarations.values) {
//
//    }
    return checkList;
  }

  // ==> Changed to modelMembers
  bool changed1() {
    var valueChanged = false;
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        if (get(v.simpleName) != null) valueChanged = true;
      }
    }
    return valueChanged;
  }

  Object copy() {
    var newObject = newClass();
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        Dynamic(newObject).set(v.simpleName, get(v.simpleName));
      }
    }
    return newObject;
  }

  bool changed(Object objectToCompare) {
    var valueChanged = false;
    if (objectToCompare == null) return false;
    for (var v in classMirror.declarations.values) {
      if (v is VariableMirror) {
        if (Dynamic(objectToCompare).get(v.simpleName) != get(v.simpleName)) {
          valueChanged = true;
          break;
        }
      }
    }
    return valueChanged;
  }

  syncableDataJsonMap() async {
    var masterJsonList = List();
    var masterJson;
    var modelRF = Models.models[clazz.runtimeType.toString()];
    if (modelRF.syncable && modelRF.syncStatusField.isNotEmpty) {
      var tableName = modelRF.model.runtimeType.toString();
      var sql = 'select * from $tableName where ${modelRF.syncStatusField.toString()} is 0';
      List modelData = await Db().get(modelRF.model, sql);
      // all master row
      for (var row in modelData) {
        masterJson = Dynamic(row).modelToDataMap();
        for (var childModelName in Dynamic(row).childModels) {
          var foreignKeyField = Db().getPrimaryKeyName(row);
          var foreignKeyValue = Db().getPrimaryKeyValue(row);
          sql = 'select * from $childModelName where ${modelRF.syncStatusField} is 0 '
              'and $foreignKeyField = \'$foreignKeyValue\'';
          var childModelData = await Db().get(Models.models[childModelName].model, sql);
          var childModelDataList = [];
          for (var childRow in childModelData) {
            childRow = Dynamic(childRow).modelToDataMap();
            childModelDataList.add(childRow);
          }
          masterJson[childModelName] = childModelDataList;
        }
        masterJsonList.add(masterJson);
      }
    }

    return masterJsonList;
  }

//+ chk FK + [Subject/Subjects] + service( 1day)

  apiJsonMapToDb(dynamic model, dynamic jsonData,
      {bool fetchIncludeChild, List<Object> fetchDependencies}) async {
    //change/back test + IncludeChild parm -> postFetchRequest

    var modelRF = Models.models[model.runtimeType.toString()];

    for (var row in jsonData) {
      var parentPrimaryKeyField = Db().getPrimaryKeyName(model);
      print('dump started on:${DateTime.now()} (${row[parentPrimaryKeyField]})');

      Dynamic(model).dataMapToModel(row);

      /*  var sql =
          'select * from ${model.runtimeType.toString()} where ${parentPrimaryKeyField} = \'${Dynamic(model).get(parentPrimaryKeyField)}\'';
      List isExists = await Db().get(model, sql);
      if (isExists.isEmpty)
        Dynamic(model).set(parentPrimaryKeyField, null);
      else {
        var pkValue = Dynamic(isExists.first).get(parentPrimaryKeyField);
        Dynamic(model).set(parentPrimaryKeyField, pkValue);
      }*/
      var parentModel = await Db().save(model);

      if (modelRF.fetchIncludeChild) {
        for (var childModelName in Dynamic(model).childModels) {
          var childJson = row['$childModelName'];
          if (childJson != null) {
            for (var childRow in childJson) {
              var childModel = Models.models[childModelName].model;
              Dynamic(childModel).dataMapToModel(childRow);
              Dynamic(childModel)
                  .set(parentPrimaryKeyField, Dynamic(parentModel).get(parentPrimaryKeyField));
              var childPrimaryKey = Db().getPrimaryKeyName(childModel);
              var sql =
                  'select * from ${childModel.runtimeType.toString()} where ${childPrimaryKey} = \'${Dynamic(childModel).get(childPrimaryKey)}\'';
              List isExists = await Db().get(childModel, sql);
              if (isExists.isEmpty) {
                //Dynamic(childModel).set(childPrimaryKey, null);
                Dynamic(childModel)
                    .set(childPrimaryKey, Dynamic(childModel).get(childPrimaryKey) ?? null);
              } else {
                var pkValue = Dynamic(isExists.first).get(parentPrimaryKeyField);
                Dynamic(childModel).set(parentPrimaryKeyField, pkValue);
              }
              await Db().save(childModel);
            }
          }
        }
      }
    }
    print('dump completed on:${DateTime.now()}');
  }

  fetchDependencyStatus(List<Object> dependencies) {
    return true;
  }

  static genericModelName(dynamic modelList) {
    print("genericModelName: " +
        modelList.runtimeType.toString().replaceAll('List<', '').replaceAll('>', ''));
    String data = modelList.runtimeType.toString().replaceAll('List<', '').replaceAll('>', '');
    print(data.replaceAll("_Growable", "").toString());
    return data.replaceAll("_Growable", "");
  }

  static methodName(dynamic functionName) {
    return functionName
        .toString()
        .replaceAll('dynamic', '')
        .replaceAll('bool', '')
        .replaceAll('from Function', '')
        .replaceAll('static', '')
        .replaceAll(':', '')
        .replaceAll('Closure () =>', '')
        .replaceAll(' ', '')
        .replaceAll('\'', '')
        .replaceAll('.', '');
  }

  static pause(int seconds) {
    sleep(Duration(seconds: seconds));
  }

//  List<ClassMirror> findSubClasses(Type type) {
//    MirrorSystem
//    ClassMirror classMirror = reflectClass(type);
//
//    return currentMirrorSystem()
//        .libraries
//        .values
//        .expand((lib) => lib.declarations.values)
//        .where((lib) {
//      return lib is ClassMirror &&
//          lib.isSubclassOf(classMirror) &&
//          lib != classMirror;
//    }).toList();
//  }
}

//flutter packages pub run build_runner build
