import 'package:flutter/cupertino.dart';
import 'package:rapidfire/RapidFire.dart';
import 'package:rapidfire/models/AppUser.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'Config.dart';
import 'ValidationRF.dart';
import 'GlobalRF.dart';

GlobalScopeRF Libs = GlobalScopeRF(); //const

class GlobalScopeRF {
  static final GlobalScopeRF _singleton = GlobalScopeRF._internal();

  Function msg;

  //Function jobWorker;
  BuildContext context;
  Configuration config;
  Models appModels = new Models();
  bool isValid = false;
  Map<String, ValidationDataRF> modelValidationData = Map();
  Map<String, Function> modelValidationFunctions = Map();
  List<Color> osBarColor = List();
  AppUser appUser = AppUser();
  SharedPref pref = SharedPref();

  prefGet(String key) async {
    var pref = await SharedPreferences.getInstance();
    return await pref.get(key);
  }

  prefSetString(String key, String value) async {
    var pref = await SharedPreferences.getInstance();
    return pref.setString(key, value);
  }

  factory GlobalScopeRF() {
    return _singleton;
  }

  GlobalScopeRF._internal();
}

class SharedPref {
  SharedPreferences _pref;

  getString(String key) async {
    _pref = _pref ?? await SharedPreferences.getInstance();
    return _pref.getString(key);
  }

  setString(String key, String value) async {
    _pref = _pref ?? await SharedPreferences.getInstance();
    _pref.setString(key, value);
  }

  getInt(String key) async {
    _pref = _pref ?? await SharedPreferences.getInstance();
    return _pref.getInt(key);
  }

  setInt(String key, int value) async {
    _pref = _pref ?? await SharedPreferences.getInstance();
    _pref.setInt(key, value);
  }

  getDouble(String key) async {
    _pref = _pref ?? await SharedPreferences.getInstance();
    return _pref.getDouble(key);
  }

  setDouble(String key, double value) async {
    _pref = _pref ?? await SharedPreferences.getInstance();
    _pref.setDouble(key, value);
  }
}

Models modelList = new Models();

class RatioRF {
  final x0_75;
  final x1_0;
  final x1_5;
  final x2_0;
  final x3_0;
  final x4_0;

  Map<String, dynamic> ratioMap = Map();

  RatioRF({this.x0_75, this.x1_0, this.x1_5, this.x2_0, this.x3_0, this.x4_0}) {
    if (x0_75 != null) ratioMap['0.75'] = this.x0_75;
    if (x1_0 != null) ratioMap['1.0'] = this.x1_0;
  }

  set(context) {
    return ratioMap[MediaQuery.of(context).devicePixelRatio.toString()];
    //MediaQuery.of(context).devicePixelRatio >= 2.5 ? 6 : 8;
  }
}
