import 'dart:collection';

class StackRF<T> {
  final _stack = Queue<T>();

  int get length => _stack.length;

  bool canPop() => _stack.isNotEmpty;

  void clearStack(){
    while(_stack.isNotEmpty){
      _stack.removeLast();
    }
  }

  void push(T element) {
    _stack.addLast(element);
  }

  T pop() {
    T lastElement = _stack.last;
    _stack.removeLast();
    return lastElement;
  }

  T peak() => _stack.last;

  bool contains(T x) {
    for (var item in _stack) {
      if (x == item) {
        return true;
      }
    }
    return false;
  }

  /// print stack
  void view() {
    for (var item in List<T>.from(_stack).reversed) {
      print(item);
    }
  }
}