import '../Annotation.dart';

class DataCMI {
  String key;
  String value;
}

@Model
class CoreCMI {
  @Key()
  String master_id;
  String student_id;
  String content_id;
  String student_name;
  String lesson_location;
  String credit;
  String lesson_status;
  String entry;
  String lesson_mode;
  String exit;
  String session_time;
  String score_raw;
  String score_min;
  String score_max;
  String suspend_data;
  String DataCollectionDate;
  int UserId;
  int DataStatus;
  List<dynamic> InteractionsCMI = [];

  CoreCMI();

  CoreCMI.fromJson(Map<String, dynamic> json)
      : master_id = json['master_id'],
        content_id = json['content_id'],
        student_id = json['student_id'],
        student_name = json['student_name'],
        lesson_location = json['cmi.core.lesson_location'],
        credit = json['cmi.core.credit'],
        lesson_status = json['cmi.core.lesson_status'],
        entry = json['cmi.core.entry'],
        lesson_mode = json['cmi.core.lesson_mode'],
        exit = json['cmi.core.exit'],
        session_time = json['cmi.core.session_time'],
        score_raw = json['cmi.core.score.raw'],
        score_min = json['cmi.core.score.min'],
        score_max = json['cmi.core.score.max'],
        suspend_data = json['cmi.suspend_data'],
        DataCollectionDate = json['DataCollectionDate'],
        UserId = json['UserId'],
        DataStatus = json['DataStatus'];

  Map<String, dynamic> toJson() => {
        'MasterId': master_id,
        'content_id': content_id,
        'student_id': student_id,
        'student_name': student_name,
        'lesson_location': lesson_location,
        'credit': credit,
        'lesson_status': lesson_status,
        'entry': entry,
        'lesson_mode': lesson_mode,
        'exit': exit,
        'session_time': session_time,
        'score_raw': score_raw,
        'score_min': score_min,
        'score_max': score_max,
        'suspend_data': suspend_data,
        'interactions': InteractionsCMI[InteractionsCMI.length - 1].toJson(),
      };
}

@Model
class InteractionsCMI {
  @Key()
  String row_id;
  String master_id;
  String interaction;
  String id;
  String time;
  String type;
  String weighting;
  String student_response;
  String result;
  String latency;
  String objectives;
  String correct_responses_pattern;
  String DataCollectionDate;
  int UserId;
  int DataStatus;

  InteractionsCMI();

  InteractionsCMI.fromJson(Map<String, dynamic> json)
      : row_id = "0",
        master_id = "0",
        interaction = json['interaction'],
        id = json['cmi.interactions.id'],
        time = json['cmi.interactions.time'],
        type = json['cmi.interactions.type'],
        weighting = json['cmi.interactions.weighting'],
        student_response = json['cmi.interactions.student_response'],
        result = json['cmi.interactions.result'],
        latency = json['cmi.interactions.latency'],
        objectives = json['cmi.interactions.objectives'],
        correct_responses_pattern = json['cmi.interactions.correct_responses_pattern'],
        DataCollectionDate = json['DataCollectionDate'],
        UserId = json['UserId'],
        DataStatus = json['DataStatus'];

  Map<String, dynamic> toJson() => {
        'row_id': row_id,
        'master_id': master_id,
        'interaction_id': interaction,
        'id': id,
        'time': time,
        'type': type,
        'weighting': weighting,
        'student_response': student_response,
        'result': result,
        'latency': latency,
        'objectives': objectives,
        'correct_responses_pattern': correct_responses_pattern,
      };
}
