import 'package:rapidfire/Annotation.dart';

@Model
class ChatGroup {
  @Key()
  String ChatGroupId;
  String Name;
  String Message;
  String SendAt;
  String SendAtTime;
  String CreatedAt;
  String GroupType;
  List<dynamic> ChatGroupMember;
}

@Model
class ChatGroupMember {
  @Key()
  String ChatGroupMemberId;
  String ChatGroupId;
  String UserId;
  String UserTable;
  String UserName;
  bool IsRemoved;

  ChatGroupMember({this.ChatGroupMemberId, this.ChatGroupId, this.UserId, this.UserTable, this.UserName, this.IsRemoved = false});
}

@Model
class ChatMessage {
  @Key()
  String ChatMessageId;
  String Message;
  String Sender;
  String SendTo;
  String SendAt;
  String Type;
  String SendAtText;
  List<String> ChatSeenUser = [];

  ChatMessage({this.ChatMessageId, this.Message, this.Sender, this.SendTo, this.SendAt, this.Type, this.SendAtText, this.ChatSeenUser});
}

@Model
class ChatSeenUser {
  @Key()
  String ChatSeenUserId;
  String UserId;
  String UserTable;
  String UserName;

  ChatSeenUser(this.ChatSeenUserId, this.UserId, this.UserTable, this.UserName);
}

@Model
class ChatUsers {
  @Key()
  String UserId;
  String UserName;
  String UserTable;

  ChatUsers({this.UserId, this.UserName, this.UserTable});
}
