import 'package:rapidfire/Annotation.dart';
import 'package:rapidfire/models/BaseModel.dart';

@Model
class CourseInfo extends BaseModel {
  @Key()
  String CourseId;
  String CatagoryId;
  String Title;
  String DescriptionTitle;
  String Description;
  String Duration;
  int CourseTypeId;
  String GradeId;
  String ThumbnailPath;

  CourseInfo({this.CourseId, this.CatagoryId, this.Title, this.DescriptionTitle, this.Description, this.Duration, this.CourseTypeId, this.ThumbnailPath, this.GradeId});
}

@Model
class UnitInfo extends BaseModel {
  @Key()
  String UnitId;
  String CourseId;
  String Title;
  String Description;
  String Duration;

  UnitInfo({this.UnitId, this.CourseId, this.Title, this.Description, this.Duration});
}

@Model
class Quiz extends BaseModel {
  @Key()
  String QuizId;
  String UnitId;
  String Title;
  String Description;
  int QuizTypeId;
  int Marks;
  int Duration;
  List<dynamic> Question;

  Quiz({this.QuizId, this.UnitId, this.Title, this.Description, this.QuizTypeId, this.Marks, this.Duration, this.Question});
}

@Model
class Question extends BaseModel {
  @Key()
  String QuestionId;
  String QuizId;
  int QuestionTypeId;
  String Title;
  String Description;
  int Marks;
  int Duration;
  String ImageUrl;
  String VideoUrl;
  List<dynamic> Options;

  Question({this.QuestionId, this.QuizId, this.QuestionTypeId, this.Title, this.Description, this.ImageUrl, this.VideoUrl, this.Marks, this.Duration, this.Options});
}

@Model
class Options {
  @Key()
  String OptionsId;
  String QuestionId;
  String Title;
  String Description;
  String Image;
  int IsCorrect;

  Options({this.OptionsId, this.QuestionId, this.Title, this.Description, this.IsCorrect, this.Image});
}

@Model
class Answer extends BaseModel {
  @Key()
  String AnswerId;
  String QuizId;
  String QuestionId;
  String SessionId;
  String OptionId;
  int IsCorrect;

  Answer({this.AnswerId, this.QuizId, this.QuestionId, this.SessionId, this.OptionId, this.IsCorrect});
}

// @Model
// class ContentInfo extends BaseModel {
//   @Key()
//   String ContentId;
//   String UnitId;
//   String Extention;
//   int ContentType;
//   int LanguageId;
//   String CourseId;
//   String SkillLevelId;
//   String Title;
//   String ShortDescription;
//   String CloudUrl;
//   String LocalUri;
//   String Image;
//   String Size;
//   bool IsPublished;
//   String Duration;
//   String Ages;
//
//   ContentInfo(
//       {this.ContentId,
//       this.UnitId,
//       this.Extention,
//       this.ContentType,
//       this.LanguageId,
//       this.CourseId,
//       this.SkillLevelId,
//       this.Title,
//       this.ShortDescription,
//       this.CloudUrl,
//       this.LocalUri,
//       this.Image,
//       this.Size,
//       this.IsPublished,
//       this.Duration,this.Ages});
// }
