//import 'package:flushbar/flushbar.dart';
import 'package:rapidfire/vendor/flushbar.dart';
import 'package:flutter/material.dart';
import 'package:flutter_custom_clippers/flutter_custom_clippers.dart';
import 'package:font_awesome_flutter/font_awesome_flutter.dart';
import 'package:rapidfire/store/ref/main.dart';
import 'package:rapidfire/uiux/DrawerRF.dart';
import 'package:rapidfire/uiux/WidgetStylesRF.dart';
import 'package:rapidfire/store/modern/config/AppLayout.dart';
import 'package:rapidfire/store/modern/onboarding/auth_page.dart';

import '../Config.dart';
import '../GlobalRF.dart';
import '../GlobalScopeRF.dart';
import '../uiux/StyleRF.dart';
import 'package:rapidfire/store/modern/onboarding/HomeRF.dart' as modern;
import 'package:rapidfire/store/modern/onboarding/Splash.dart' as modern;
import 'package:rapidfire/store/modern/onboarding/Login.dart' as modern;
import 'package:rapidfire/store/modern/onboarding/Otp.dart' as modern;
import 'package:rapidfire/store/modern/onboarding/Setup.dart' as modern;
import 'package:rapidfire/store/modern/onboarding/Language.dart' as modern;
import 'package:rapidfire/store/modern/onboarding/Language.dart';
import 'package:rapidfire/store/modern/onboarding/InternetUsage.dart';
import '../uiux/WidgetsRF.dart';

//import 'package:sizer/sizer.dart';
import 'package:rapidfire/store/modern/config/defaults/StoreOutlineDefaults.dart';
export 'package:rapidfire/store/modern/config/defaults/StoreOutlineDefaults.dart';

class StoreRF {
  static Onboard onboard = Onboard();
  static Outline outline = Outline(); //Outline -> Drawer, type selection

  static ImplementationStoreDefaults implementation(TemplateRF template) {
    dynamic _scaffold;
    ImplementationStoreDefaults implementationStoreDefaults = ImplementationStoreDefaults(_scaffold);

    template = TemplateRF.get(template);
    if (template.name == TemplateNameRF.modern) _scaffold = AppLayout();
    if (template.name == TemplateNameRF.classic) _scaffold = AppLayout();
    implementationStoreDefaults.page = PageImplementationStoreDefaults(outline: _scaffold as IPageOutlineRF);

    return implementationStoreDefaults;
  }

  static ScaffoldStoreDefaults scaffold({
    TemplateRF template,
    BuildContext context,
    dynamic model,
    Function onTap,
  }) {
    if (template == null) template = TemplateRF.get();
    ScaffoldStoreDefaults scaffoldStoreDefaults = ScaffoldStoreDefaults();

    scaffoldStoreDefaults.outline = StoreOutlineDefaults(template); //drawerItems
    scaffoldStoreDefaults.app = ScaffoldStoreDefaultsApp(template); //modern ui, validated pop
    scaffoldStoreDefaults.widgets = ScaffoldStoreDefaultsWidgets(template: template, model: model, onTap: onTap); //tab bar
    scaffoldStoreDefaults.widgets.tabBar = ScaffoldStoreDefaultsWidgetsTabBar(template); //tab bar

    return scaffoldStoreDefaults;
  }

  static StyleStoreDefaults style(TemplateRF template) {
    dynamic _styles;

    template = TemplateRF.get(template);
    if (template.name == TemplateNameRF.classic) _styles = AppLayout();
    if (template.name == TemplateNameRF.modern) _styles = AppLayout(); //classic class

    return StyleStoreDefaults(text: _styles as ITextRFStyle, container: _styles);
  }
}

class PageImplementationStoreDefaults {
//  final dynamic everything;//
//  final IDrawerScaffoldRF drawer;//
//  final IAppBarScaffoldRF appBar;//
  final IPageOutlineRF outline;

  final IPageRF appBar;

  const PageImplementationStoreDefaults({this.outline, this.appBar} /*this.everything, this.appBar, this.drawer,*/);
}

class ImplementationStoreDefaults {
  PageImplementationStoreDefaults page;

  IPageRF iPageRF;

  ImplementationStoreDefaults(IPageRF iPageRF) {
    this.iPageRF = iPageRF;
  }
}

class ScaffoldStoreDefaults {
  StoreOutlineDefaults outline;
  ScaffoldStoreDefaultsApp app;
  ScaffoldStoreDefaultsWidgets widgets;
}

class ScaffoldStoreDefaultsWidgets {
  TemplateRF _template;
  BuildContext _context;
  dynamic _model;
  Function _onTap;

  ScaffoldStoreDefaultsWidgets({TemplateRF template, BuildContext context, dynamic model, Function onTap}) {
    if (template == null) template = TemplateRF.get();
    _template = template;
    _context = context;
    _onTap = onTap;
  }

  get leading {
    if (_template.name == TemplateNameRF.modern && _template.version.contains('iOS')) {
      return InkWell(
        onTap: () => _onTap(), //rf.page.back(_context),
        child: Icon(Icons.arrow_back_ios, color: Colors.black),
      );
    }
  }

  ScaffoldStoreDefaultsWidgetsTabBar tabBar;
}

class ScaffoldStoreDefaultsWidgetsTabBar {
  TemplateRF _template;

  ScaffoldStoreDefaultsWidgetsTabBar([TemplateRF template]) {
    template = TemplateRF.get();
    _template = template;
  }

  getStyle(int index, int currentIndex, {String label, Icon icon, double labelWidth = 150}) {
    return Container(
      width: labelWidth,
      decoration: BoxDecoration(
        color: currentIndex == index ? Colors.white : Colors.transparent,
        borderRadius: BorderRadius.circular(50),
        border: Border.all(
          color: currentIndex == index ? Colors.white : Colors.white,
          width: currentIndex == index ? 0 : 2,
        ),
      ),
      child: Row(
        children: <Widget>[
          Padding(
            padding: EdgeInsets.only(
              top: currentIndex == index ? 3 : 2,
              bottom: currentIndex == index ? 2 : 2.5,
              left: currentIndex == index ? 3 : 0,
            ),
            child: CircleAvatar(
              child: Text(
                (index + 1).toString(),
                style: TextStyle(
                    fontSize: 20, fontWeight: FontWeight.bold, color: currentIndex == index ? Colors.white : Colors.blue),
              ),
              radius: 18,
              backgroundColor: currentIndex == index ? Colors.blue : Colors.white,
              foregroundColor: currentIndex == index ? Colors.white : Colors.blue,
            ),
          ),
          Expanded(
            child: Padding(
              padding: const EdgeInsets.only(top: 2.0),
              child: Align(
                alignment: Alignment.center,
                child: Text(
                  label,
                  style: TextStyle(
                      fontWeight: FontWeight.bold, fontSize: 16, color: currentIndex == index ? Colors.blue : Colors.white),
                ),
              ),
            ),
          ),
        ],
      ),
    );
  }
}

class StyleStoreDefaults {
  final dynamic all;
  final ITextRFStyle text;
  final IContainerRFStyle container;

  const StyleStoreDefaults({this.all, this.text, this.container});
}

class Onboard {
  splash(Configuration _configuration, {TemplateRF template}) {
    var splash;
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
      case TemplateNameRF.material:
        if (_configuration.app.onboard is AppOnboardRF) {
          splash = _configuration.app.onboard?.splash ?? modern.Splash();
        } else {
          splash = _configuration.app.onboard?.customOnboard()?.splash ?? modern.Splash();
        }
        break;
    }
    return splash;
  }

  language(Configuration _configuration, {TemplateRF template}) {
    var language;
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
      case TemplateNameRF.material:
        if (_configuration.app.onboard is AppOnboardRF) {
          language = _configuration.app.onboard?.language ?? modern.LanguageSelection(isOnboarding: false);
        } else {
          language = _configuration.app.onboard?.customOnboard()?.language ?? modern.LanguageSelection(isOnboarding: false);
        }
        break;
    }
    return language;
  }

  intro(Configuration _configuration, {TemplateRF template}) {
    //'Not Implemented'
  }

  login(Configuration _configuration, {TemplateRF template}) {
    var login;
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
      case TemplateNameRF.material:
        if (_configuration.app.onboard is AppOnboardRF) {
          login = _configuration.app.onboard?.login ?? modern.Login();
        } else {
          login = _configuration.app.onboard?.customOnboard()?.login ?? modern.Login();
        }
        break;
    }
    return login;
  }

  otp(Configuration _configuration, {TemplateRF template}) {
    var otp;
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
      case TemplateNameRF.material:
        if (_configuration.app.onboard is AppOnboardRF) {
          otp = _configuration.app.onboard?.otp ?? modern.Otp();
        } else {
          otp = _configuration.app.onboard?.customOnboard()?.otp ?? modern.Otp();
        }
        break;
    }
    return otp;
  }

  setup(Configuration _configuration, {TemplateRF template}) {
    var setup;
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
      case TemplateNameRF.material:
        if (_configuration.app.onboard is AppOnboardRF) {
          setup = _configuration.app.onboard?.initialSetup ?? modern.Setup();
        } else {
          setup = _configuration.app.onboard?.customOnboard()?.initialSetup ?? modern.Setup();
        }
        break;
    }
    return setup;
  }
}

// type of drawer selection
class Outline {
  drawer(
    BuildContext context,
    String title,
    String subTitle,
    String imagePath,
    Color circleColor, [
    TemplateRF template,
  ]) {
    var drawerModernOval = DrawerRF(
        clipper: OvalRightBorderClipper(),
        menuHeader: Column(
          crossAxisAlignment: CrossAxisAlignment.stretch,
          children: <Widget>[
            Container(
              color: Colors.red,
              height: 240,
              padding: EdgeInsets.only(top: 15),
              child: StoreOutlineDefaults().storeOutline().header.drawer.drawerHeader(
                    title,
                    subTitle,
                    imagePath,
                    circleColor,
                    template: template,
                    context: context,
                  ),
            )
          ],
        ),
        menuBody: StoreOutlineDefaults()
            .storeOutline()
            .header
            .drawer
            .menuBody(context, separator: true, textWeight: FontWeight.bold, template: template),
        menuFooter: StoreOutlineDefaults()
            .storeOutline()
            .header
            .drawer
            .drawerFooter(context, color: Colors.pink, separator: false, template: template)
//      DrawerItemRF(
//        icon: FontAwesomeIcons.headphonesAlt,
//        text: 'Support',
//        color: Colors.pink,
//        separator: false,
//        template: template,
//      ),
        );

    var drawerMaterialDefault = DrawerRF(
      menuHeader: Container(
        color: Colors.red,
        child: StoreOutlineDefaults().storeOutline().header.drawer.drawerHeader(
              title,
              subTitle,
              imagePath,
              circleColor,
              template: template,
              context: context,
            ),
//        DrawerHeader(
//          child: Column(
//            crossAxisAlignment: CrossAxisAlignment.stretch,
//            mainAxisAlignment: MainAxisAlignment.start,
//            children: <Widget>[
//              Padding(
//                padding: const EdgeInsets.only(right: 8.0),
//                child: CircleAvatar(
//                  radius: 45,
//                  backgroundColor: Color(0xffFDCF09),
//                  child: CircleAvatar(
//                      radius: 40, backgroundImage: AssetImage('assets/images/profile.png')),
//                ),
//              ),
//              SizedBox(height: 5),
//              Text(
//                'Drawer Header',
//                style: TextStyle(fontWeight: FontWeight.bold, color: Colors.white, fontSize: 18),
//              ),
//              Text('Sonething', style: TextStyle(color: Colors.white)),
//            ],
//          ),
//          decoration: BoxDecoration(color: Colors.blue),
//        ),
      ),
      menuBody: StoreOutlineDefaults()
          .storeOutline()
          .header
          .drawer
          .menuBody(context, separator: false, textWeight: FontWeight.w500, template: template),
      menuFooter: StoreOutlineDefaults()
          .storeOutline()
          .header
          .drawer
          .drawerFooter(context, separator: false, padding: 10, color: Colors.pink, template: template),
//      DrawerItemRF(
//          icon: FontAwesomeIcons.headphonesAlt,
//          text: 'Support',
//          color: Colors.pink,
//          separator: false,
//          template: template),
    );

    template = TemplateRF.get(template);
    if (template.name == TemplateNameRF.modern && template.version == 'Oval') return drawerModernOval;
    if (template.name == TemplateNameRF.material) return drawerMaterialDefault;
  }
}

//https://buildflutter.com/functional-programming-with-flutter/

class ScaffoldStoreDefaultsApp {
  var validatedPop;
  var modernUI;

  ScaffoldStoreDefaultsApp(TemplateRF template) {
    validatedPop = _validatedPopFn;
    modernUI = _modernUI;
  }

  _modernUI(BuildContext context) {
    rf.page.call(context, MyApp());
  }

  _validatedPopFn(BuildContext context) {
    print('back');
    Flushbar(
      //title:  "Hey Ninja",
      messageText: Text(
        "Save change pending, do you wnat to quit?",
        style: TextStyle(fontWeight: FontWeight.normal, fontSize: 18.0, color: Colors.black, fontFamily: "ShadowsIntoLightTwo"),
      ),
      duration: Duration(seconds: 10),
      margin: EdgeInsets.all(20),
      borderRadius: 50,
      backgroundColor: Colors.red,
      icon: Icon(Icons.check, color: Colors.black),
      mainButton: Padding(
        padding: const EdgeInsets.only(right: 6.0),
        child: FlatButton(
          shape: new RoundedRectangleBorder(borderRadius: new BorderRadius.circular(50.0)),
          color: Colors.white,
          onPressed: () {
            Navigator.of(context).pop(true);
          },
          child: Text(
            "Quit",
            style: TextStyle(color: Colors.black, fontWeight: FontWeight.bold, fontSize: 18.0),
          ),
        ),
      ),
    )..show(context);

//    Scaffold.of(context).showSnackBar(SnackBar(
//        content: Text("Save change pending!"),
//        action: SnackBarAction(
//          label: 'Back Anyway',
//          onPressed: () {
//            // back pop
//          },
//        )));
  }
}
