import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:rapidfire/GlobalScopeRF.dart';
import 'package:rapidfire/uiux/DrawerRF.dart';
import 'package:rapidfire/uiux/StyleRF.dart';
import 'package:rapidfire/uiux/WidgetStylesRF.dart';
import 'package:rapidfire/uiux/WidgetsRF.dart';

import '../../../GlobalRF.dart';

class AppLayout implements IPageOutlineRF, ITextRFStyle, IContainerRFStyle {
  @override
  OutlineRF customOutline({Function onDrawerItemClick}) {
    return OutlineRF(
      appBar: customAppBar(), //drawer: customDrawer(),
      footer: customBottomBar,
    );
  }

  @override
  StyleTextRF textRFStyle() {
    return null;
    return StyleTextRF(
      fontSize: 15,
      fontWeight: FontWeight.bold,
      color: Colors.blue,
    );
  }

  @override
  StyleContainerRF containerRFStyle() {
    return StyleContainerRF(
      alignment: Alignment(0, 0),
      padding: EdgeInsets.all(10),
      margin: EdgeInsets.all(10),
      decoration: BoxDecoration(
          color: Libs.config.app.theme.widgets.backColor ?? Colors.white,
          boxShadow: [
            BoxShadow(
              color: Colors.grey.withOpacity(0.6),
              spreadRadius: 2,
              blurRadius: 2,
              offset: Offset(0, 1), // changes position of shadow
            ),
          ],
          borderRadius: BorderRadius.all(Radius.circular(4))),
    );
  }
}

//class DefaultScaffold
//    implements IAppBarScaffoldRF, IDrawerScaffoldRF {
//  @override
//  Widget attachDrawer() {
//    return customDrawer();
//  }
//
//  @override
//  AppBar attachAppBar(String title, TabBar tabBar) {
//    return customAppBar(title, tabBar);
//  }
//}

dynamic customActions() {
  return <Widget>[
    IconButton(
      icon: Icon(Icons.search),
      onPressed: () {
        // clicked(context, "Message sent");
      },
    ),
    PopupMenuButton(
      itemBuilder: (BuildContext context) {
        return [
          PopupMenuItem(
            child: Column(
              children: <Widget>[
                Text('Client Global Menu 1'),
                Text('Client Global Menu 2'),
              ],
            ),
          ),
        ];
      },
    )
  ];
}

dynamic customAppBar() {
  return AppBarRF(
    leading: Icon(Icons.language),
    actions: customActions(),
    drawer: customDrawer(),
  );
  return AppBar(
    backgroundColor: Colors.blue,
    bottom: null,
    // leading: Icon(Icons.import_contacts), //AppBar Left Icon
    title: null,
    actions: <Widget>[
      IconButton(
        icon: Icon(Icons.search),
        onPressed: () {
          // clicked(context, "Message sent");
        },
      ),
      PopupMenuButton(
        itemBuilder: (BuildContext context) {
          return [
            PopupMenuItem(
              child: Column(
                children: <Widget>[
                  Text('App Default Menu 1'),
                  Text('App Default Menu 2'),
                ],
              ),
            ),
          ];
        },
      )
    ],
  );
}

Widget customDrawer() {
  TemplateRF template = Libs.config.app.template;
  return DrawerRF(template: template ?? TemplateRF(TemplateNameRF.modern, version: 'Oval'));
}

var customBottomBar = BottomNavigationBar(
  currentIndex: 1,
  type: BottomNavigationBarType.fixed,
  onTap: null,
  items: [
    BottomNavigationBarItem(
      icon: new Icon(Icons.dashboard),
      title: Text(rf.lang.text('', 'page_one')),
    ),
    BottomNavigationBarItem(
      icon: new Icon(Icons.gesture),
      title: new Text(rf.lang.text('', 'page_two')),
    ),
    BottomNavigationBarItem(
      icon: Icon(Icons.timelapse),
      title: Text(rf.lang.text('', 'page_three')),
    )
  ],
);

var customTabBar = TabBuilderRF(
  controller: null,
  tabs: <Widget>[Tab(text: "tab 1"), Tab(text: "tab 2"), Tab(text: "tab 3")],
  views: <Widget>[Text('hi'), Text('hi'), Text('hi')],
);
