import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:rapidfire/store/modern/dashboard/DashBoard.dart';
import 'colors.dart';
import 'size.dart';
import 'strings.dart';
import '../../../GlobalScopeRF.dart';
import 'piechartcustompainter.dart';

class PieChart extends StatefulWidget {
  List<appContent> items;
  PieChart(this.items);

  @override
  _PieChartState createState() => _PieChartState();
}

class _PieChartState extends State<PieChart> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    var width = SizeConfig.getWidth(context);
    double fontSize(double size) {
      return size * width / 414;
    }

    return LayoutBuilder(
      builder: (context, constraint) {
        return Container(
          decoration:
              BoxDecoration(color: AppColors.primaryWhite, shape: BoxShape.circle, boxShadow: AppColors.neumorpShadow),
          child: Stack(
            children: <Widget>[
              Center(
                child: SizedBox(
                  width: constraint.maxWidth * 0.6,
                  child: CustomPaint(
                    child: Center(),
                    foregroundPainter: PieChartCustomPainter(width: constraint.maxWidth * 0.5, items: widget.items),
                  ),
                ),
              ),
              Center(
                child: Container(
                  width: constraint.maxWidth * .3,
                  decoration:
                      BoxDecoration(color: Colors.white, shape: BoxShape.circle, boxShadow: AppColors.neumorpShadow),
                  child: Center(child: Image.asset(Libs.config.app.appLogo)),
                ),
              )
            ],
          ),
        );
      },
    );
  }
}
