import 'dart:math';

import 'package:flutter/material.dart';
import 'DashBoard.dart';
import 'colors.dart';

class PieChartCustomPainter extends CustomPainter {
  List<appContent> items;
  final double width;
  PieChartCustomPainter({this.items, this.width});
  @override
  void paint(Canvas canvas, Size size) {
    Offset center = Offset(size.width / 2, size.height / 2);
    double radius = min(size.width / 2, size.height / 2);
    double total = 0;
    double startRadian = -pi / 2;
    var paint = Paint()
      ..style = PaintingStyle.stroke
      ..strokeWidth = width - 50;
    items.forEach((f) => total += f.DataCount);
    for (var i = 0; i < items.length; i++) {
      final currentCategory = items[i];
      final sweepRadian = currentCategory.DataCount / total * 2 * pi;
      paint.color = AppColors.pieColors[i % items.length];
      canvas.drawArc(Rect.fromCircle(center: center, radius: radius), startRadian, sweepRadian, false, paint);
      startRadian += sweepRadian;
    }
  }

  @override
  bool shouldRepaint(CustomPainter oldDelegate) => true;
}
