import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import '../../../BGHelperDB.dart';
import 'package:rapidfire/RapidFire.dart';

class InternetUsage extends StatefulWidget {
  final List<Color> availableColors = [
    Colors.pink,
    Colors.purpleAccent,
    Colors.yellow,
    Colors.lightBlue,
    Colors.orange,
    Colors.redAccent,
  ];

  @override
  _InternetUsageState createState() => _InternetUsageState();
}

class _InternetUsageState extends State<InternetUsage> {
  ScrollController _scrollController = new ScrollController();
  final dbHelper = BGHelperDB.instance;
  var internetUsage = 0;
  int colorindex = 0;
  int totalRequests = 0;
  int todayUsage = 0;
  int monthUsage = 0;
  List<usageItem> items = [];
  usageItem lastRequest = new usageItem();

  @override
  void initState() {
    // TODO: implement initState
    getData();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.white,
      body: Stack(
        children: [
          Padding(
            padding: EdgeInsets.all(10),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              crossAxisAlignment: CrossAxisAlignment.center,
              children: [
                TweenAnimationBuilder(
                  tween: Tween<double>(begin: 100, end: 1),
                  curve: Curves.fastLinearToSlowEaseIn,
                  duration: Duration(milliseconds: 1200),
                  builder: (BuildContext context, double size, Widget child) {
                    return Transform.scale(
                      scale: size,
                      child: Container(
                        margin: EdgeInsets.only(top: 40),
                        width: 150,
                        height: 150,
                        decoration: BoxDecoration(
                          boxShadow: [
                            BoxShadow(
                                offset: Offset(-4, -4),
                                color: Colors.black38.withOpacity(0.1),
                                blurRadius: 10),
                            BoxShadow(
                                offset: Offset(4, 4), color: Colors.black38.withOpacity(0.1), blurRadius: 10)
                          ],
                          borderRadius: BorderRadius.circular(30.0),
                        ),
                        child: Center(
                          child: Container(
                            width: 140,
                            height: 140,
                            decoration: BoxDecoration(
                              boxShadow: [
                                BoxShadow(offset: Offset(6, 6), color: Colors.black38, blurRadius: 20),
                                BoxShadow(
                                    offset: Offset(-6, -6),
                                    color: Colors.white.withOpacity(0.85),
                                    blurRadius: 20)
                              ],
                              color: Colors.white38,
                              borderRadius: BorderRadius.circular(30.0),
                            ),
                            child: Center(
                              child: Column(
                                mainAxisAlignment: MainAxisAlignment.center,
                                children: [
                                  Text(
                                    internetUsage > 1000
                                        ? (internetUsage / 1000).toString()
                                        : internetUsage.toString(),
                                    style: TextStyle(
                                      fontSize: 50,
                                      fontWeight: FontWeight.w500,
                                      color: Colors.pinkAccent,
                                    ),
                                  ),
                                  Text(
                                    internetUsage > 1000 ? "MB" : "KB",
                                    style: TextStyle(
                                        fontSize: 18, fontWeight: FontWeight.w500, color: Colors.black87),
                                  ),
                                  Text(
                                    "Total Usage",
                                    style: TextStyle(
                                        fontSize: 12, fontWeight: FontWeight.w500, color: Colors.black26),
                                  ),
                                ],
                              ),
                            ),
                          ),
                        ),
                      ),
                    );
                  },
                ),
                Container(
                  margin: EdgeInsets.only(top: 50),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceAround,
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: [
                      TweenAnimationBuilder(
                          tween: Tween<double>(begin: -100, end: 0),
                          curve: Curves.easeInOutSine,
                          duration: Duration(milliseconds: 1600),
                          builder: (BuildContext context, double size, Widget child) {
                            return Transform.translate(
                              offset: Offset(size, 0.0),
                              child: Container(
                                width: 100,
                                height: 100,
                                padding: EdgeInsets.symmetric(horizontal: 10),
                                decoration: BoxDecoration(
                                  boxShadow: [
                                    BoxShadow(offset: Offset(5, 5), color: Colors.black38, blurRadius: 20),
                                    BoxShadow(
                                        offset: Offset(-10, -10),
                                        color: Colors.white.withOpacity(0.85),
                                        blurRadius: 20)
                                  ],
                                  color: Color(0Xffff595e).withOpacity(0.5),
                                  borderRadius: BorderRadius.circular(100.0),
                                ),
                                child: Center(
                                  child: Column(
                                    mainAxisAlignment: MainAxisAlignment.center,
                                    children: [
                                      SizedBox(
                                        height: 5,
                                      ),
                                      Text(
                                        totalRequests.toString(),
                                        style: TextStyle(
                                            fontSize: 22, fontWeight: FontWeight.w600, color: Colors.white),
                                      ),
                                      Text(
                                        "Requests",
                                        style: TextStyle(
                                            fontSize: 13, fontWeight: FontWeight.normal, color: Colors.white),
                                      ),
                                    ],
                                  ),
                                ),
                              ),
                            );
                          }),
                      TweenAnimationBuilder(
                          tween: Tween<double>(begin: -100, end: 0),
                          curve: Curves.easeInOutSine,
                          duration: Duration(milliseconds: 1600),
                          builder: (BuildContext context, double size, Widget child) {
                            return Transform.translate(
                              offset: Offset(0.0, size),
                              child: Container(
                                width: 100,
                                height: 100,
                                padding: EdgeInsets.symmetric(horizontal: 10),
                                decoration: BoxDecoration(
                                  boxShadow: [
                                    BoxShadow(offset: Offset(5, 5), color: Colors.black38, blurRadius: 20),
                                    BoxShadow(
                                        offset: Offset(-10, -10),
                                        color: Colors.white.withOpacity(0.85),
                                        blurRadius: 20)
                                  ],
                                  color: Color(0xff2a9d8f).withOpacity(0.4),
                                  borderRadius: BorderRadius.circular(100.0),
                                ),
                                child: Center(
                                  child: Column(
                                    mainAxisAlignment: MainAxisAlignment.center,
                                    children: [
                                      SizedBox(
                                        height: 5,
                                      ),
                                      Text(
                                        todayUsage.toString() + " kb",
                                        style: TextStyle(
                                            fontSize: 22, fontWeight: FontWeight.w600, color: Colors.white),
                                      ),
                                      Text(
                                        "Today",
                                        style: TextStyle(
                                            fontSize: 13, fontWeight: FontWeight.normal, color: Colors.white),
                                      ),
                                    ],
                                  ),
                                ),
                              ),
                            );
                          }),
                      TweenAnimationBuilder(
                          tween: Tween<double>(begin: 100, end: 0),
                          curve: Curves.easeInOutSine,
                          duration: Duration(milliseconds: 1600),
                          builder: (BuildContext context, double size, Widget child) {
                            return Transform.translate(
                              offset: Offset(size, 0.0),
                              child: Container(
                                width: 100,
                                height: 100,
                                padding: EdgeInsets.symmetric(horizontal: 10),
                                decoration: BoxDecoration(
                                  boxShadow: [
                                    BoxShadow(offset: Offset(5, 5), color: Colors.black38, blurRadius: 20),
                                    BoxShadow(
                                        offset: Offset(-10, -10),
                                        color: Colors.white.withOpacity(0.85),
                                        blurRadius: 20)
                                  ],
                                  color: Color(0Xff1982c4).withOpacity(0.4),
                                  borderRadius: BorderRadius.circular(100.0),
                                ),
                                child: Center(
                                  child: Column(
                                    mainAxisAlignment: MainAxisAlignment.center,
                                    children: [
                                      SizedBox(
                                        height: 5,
                                      ),
                                      Text(
                                        monthUsage > 1000
                                            ? ((monthUsage / 1000).toString() + " MB")
                                            : (monthUsage.toString() + " kb"),
                                        style: TextStyle(
                                            fontSize: 22, fontWeight: FontWeight.w600, color: Colors.white),
                                      ),
                                      Text(
                                        "This Month",
                                        style: TextStyle(
                                            fontSize: 13, fontWeight: FontWeight.normal, color: Colors.white),
                                      ),
                                    ],
                                  ),
                                ),
                              ),
                            );
                          }),
                    ],
                  ),
                ),
                Expanded(
                  child: Container(
                    margin: EdgeInsets.only(top: 20),
                    height: 300,
                    child: ListView.builder(
                        padding: EdgeInsets.all(0),
                        controller: _scrollController,
                        itemCount: items.length,
                        scrollDirection: Axis.horizontal,
                        itemBuilder: (BuildContext context, int index) {
                          Color c = getColor();
                          return Container(
                            margin: EdgeInsets.symmetric(horizontal: 16),
                            child: Column(
                              mainAxisAlignment: MainAxisAlignment.center,
                              children: [
                                Stack(
                                  alignment: AlignmentDirectional.bottomCenter,
                                  children: [
                                    Container(
                                      height: 220,
                                      width: 2,
                                      decoration: BoxDecoration(
                                        color: Colors.grey[200],
                                        borderRadius: BorderRadius.circular(10.0),
                                      ),
                                    ),
                                    Column(
                                      children: [
                                        Container(
                                          height: 30,
                                          width: 30,
                                          decoration: BoxDecoration(
                                            boxShadow: [
                                              BoxShadow(offset: Offset(0, 0), color: c, blurRadius: 2),
                                            ],
                                            color: Colors.white.withOpacity(0.8),
                                            borderRadius: BorderRadius.circular(100.0),
                                          ),
                                          child: Center(
                                              child: Text(
                                            items[index].DataSize.toString(),
                                            style: TextStyle(fontSize: 11),
                                          )),
                                        ),
                                        TweenAnimationBuilder(
                                          tween: Tween<double>(begin: 0, end: 1),
                                          duration: Duration(seconds: 3),
                                          builder: (BuildContext context, double size, Widget child) {
                                            return Container(
                                              height: items[index].DataSize >= 200
                                                  ? 220
                                                  : (items[index].DataSize * 1.1) * size,
                                              width: 14,
                                              decoration: BoxDecoration(
                                                boxShadow: [
                                                  BoxShadow(offset: Offset(0, 0), color: c, blurRadius: 2),
                                                ],
                                                color: c,
                                                borderRadius: BorderRadius.circular(10.0),
                                              ),
                                            );
                                          },
                                        ),
                                      ],
                                    ),
                                  ],
                                ),
                                SizedBox(
                                  height: 15,
                                ),
                                Text(
                                  items[index].Date,
                                  style: TextStyle(fontSize: 11, color: Colors.grey[600]),
                                )
                              ],
                            ),
                          );
                        }),
                  ),
                ),
                TweenAnimationBuilder(
                    tween: Tween<double>(begin: 200, end: 0),
                    curve: Curves.easeInOutSine,
                    duration: Duration(milliseconds: 2000),
                    builder: (BuildContext context, double size, Widget child) {
                      return Transform.translate(
                        offset: Offset(size, 0.0),
                        child: Row(
                          children: [
                            Container(
                              margin: EdgeInsets.only(left: 20),
                              width: 100,
                              height: 30,
                              decoration: BoxDecoration(
                                boxShadow: [
                                  BoxShadow(offset: Offset(0, 0), color: Colors.black38, blurRadius: 5),
                                ],
                                color: Colors.white,
                                borderRadius: BorderRadius.circular(30.0),
                              ),
                              child: Center(
                                child: Text("Last Call",
                                    style: TextStyle(
                                        fontSize: 16,
                                        fontWeight: FontWeight.w600,
                                        color: Colors.red.shade200)),
                              ),
                            ),
                            Container(
                              width: 1,
                              height: 70,
                              margin: EdgeInsets.symmetric(horizontal: 20),
                              color: Colors.grey.shade300,
                            ),
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                                Align(
                                    alignment: Alignment.centerLeft,
                                    child: Text(lastRequest.TableName,
                                        style: TextStyle(fontSize: 20, fontWeight: FontWeight.w600))),
                                Align(
                                    alignment: Alignment.centerLeft,
                                    child: Text(lastRequest.Date + "  at  " + lastRequest.Time,
                                        style: TextStyle(
                                            fontSize: 15, fontWeight: FontWeight.w400, color: Colors.grey))),
                                Align(
                                    alignment: Alignment.centerLeft,
                                    child: Text("Data Usage : " + lastRequest.DataSize.toString() + " kb",
                                        style: TextStyle(
                                            fontSize: 15, fontWeight: FontWeight.w400, color: Colors.grey))),
                              ],
                            )
                          ],
                        ),
                      );
                    }),
                SizedBox(
                  height: 20,
                ),
              ],
            ),
          ),
          Positioned(
              top: 35,
              left: 10,
              child: InkWell(
                  onTap: () {
                    rf.page.back(context);
                  },
                  child: Icon(Icons.arrow_back_ios_outlined))),
        ],
      ),
    );
  }

  void getData() async {
    internetUsage = await dbHelper.getInternetUsage();
    var ret = await dbHelper.get("select count(*) as count from DataUsageHistory", null);
    totalRequests = ret.first["count"];

    var data = await dbHelper.get("select * from DataUsageHistory order by RecordId desc limit 1", null);

    lastRequest = usageItem(
        TableName: data.first["TableName"],
        Date: data.first["Date"],
        Time: data.first["Time"],
        DataSize: data.first["Size"]);

    var rets = await dbHelper.get(
        "select sum(Size) as Size from DataUsageHistory where Date like '" +
            Jiffy().format("do MMM yy") +
            "\'",
        null);
    todayUsage = rets.first["Size"];

    var retm = await dbHelper.get(
        "select sum(Size) as Size from DataUsageHistory where Date like '%" + Jiffy().format("MMM yy") + "'",
        null);
    monthUsage = retm.first["Size"];

    var sql = 'select sum(Size) as DataSize, Date from DataUsageHistory group by date limit 30';
    var datas = await dbHelper.get(sql, null);
    for (int i = 0; i < datas.length; i++) {
      items.add(usageItem(Date: datas[i]["Date"], DataSize: datas[i]["DataSize"]));
    }

/*    items.add(usageItem(Date: "12-05-20", DataSize: 100));
    items.add(usageItem(Date: "12-05-20", DataSize: 80));
    items.add(usageItem(Date: "12-05-20", DataSize: 0));
    items.add(usageItem(Date: "12-05-20", DataSize: 20));
    items.add(usageItem(Date: "12-05-20", DataSize: 70));
    items.add(usageItem(Date: "12-05-20", DataSize: 25));
    items.add(usageItem(Date: "12-05-20", DataSize: 40));
    items.add(usageItem(Date: "12-05-20", DataSize: 20));
    items.add(usageItem(Date: "12-05-20", DataSize: 10));
    items.add(usageItem(Date: "12-05-20", DataSize: 25));
    items.add(usageItem(Date: "12-05-20", DataSize: 40));*/
    setState(() {});
  }

  Color getColor() {
    if (colorindex == widget.availableColors.length) colorindex = 0;
    Color c = widget.availableColors[colorindex];
    colorindex++;
    return c;
  }
}

//items model
class usageItem {
  String TableName;
  String Date;
  String Time;
  int DataSize;

  usageItem({this.TableName = "", this.Date = "", this.Time = "", this.DataSize = 0});
}
