import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:rapidfire/uiux/intro/Models/page_view_model.dart';
import 'package:rapidfire/uiux/intro/intro_views_flutter.dart';
import '../../../GlobalRF.dart';
import 'package:rapidfire/RapidFire.dart';

class Intro extends StatefulWidget {
  List<IntroPageViewRF> pages;

  @override
  _IntroState createState() => _IntroState();
  Intro({this.pages});
}

class _IntroState extends State<Intro> {
  @override
  Widget build(BuildContext context) {
    var _fontDescriptionStyle = TextStyle(fontFamily: "Sans", fontSize: 15.0, color: Colors.black26, fontWeight: FontWeight.w400);

    return IntroViewsFlutter(
      widget.pages,
      pageButtonsColor: Colors.black45,
      skipText: TextRF(
        "SKIP",
        style: _fontDescriptionStyle.copyWith(color: Colors.deepPurpleAccent, fontWeight: FontWeight.w400, letterSpacing: 1.0),
      ),
      doneText: TextRF(
        "DONE",
        style: _fontDescriptionStyle.copyWith(color: Colors.deepPurpleAccent, fontWeight: FontWeight.w400, letterSpacing: 1.0),
      ),
      onTapDoneButton: () {
        rf.page.replace(context, rf.onboard.next()); //Login()
      },
      pageButtonTextStyles: TextStyle(
        color: Colors.white,
        fontSize: 18.0,
      ),
    );
  }
}
