import 'package:flutter/material.dart';
import 'package:rapidfire/RapidFire.dart';
import 'package:rapidfire/LocalizationProviderRF.dart';

class LanguageSelection extends StatefulWidget {
  final bool isOnboarding;
  final String title;
  List<LanguageItems> languages = [];

  @override
  _LanguageState createState() => _LanguageState();

  LanguageSelection({this.languages, this.isOnboarding = true, this.title});
}

class _LanguageState extends State<LanguageSelection> {
  Configuration config = new Configuration();

  @override
  Widget build(BuildContext context) {
    // config.app.themeData.customThemeData(themeType)

/*    LanguageItems filea = new LanguageItems(
      name: "English",
      text: "This is English Language",
      img: 'assets/images/lan-en.png',
      isOnboarding: widget.isOnboarding,
    );
    LanguageItems fileb = new LanguageItems(
      name: "Bangla",
      text: "এটি বাংলা ভাষা",
      img: "assets/images/lan-bg.png",
      isOnboarding: widget.isOnboarding,
    );
*/ /*    LanguageItems filec = new LanguageItems(
      name: "Sinhala",
      text: "මෙය ඉංග්‍රීසි භාෂාවයි",
      img: "assets/images/lan-sl.jpg",
      isOnboarding: widget.isOnboarding,
    );*/ /*

    setState(() {
      widget.languages.clear();
      for(LanguageItems languageItems in widget.languages){
        widget.languages.add(languageItems);
      }
      //_languages.add(filec);
    });*/

    return Scaffold(
      appBar: AppBar(
        leading: InkWell(
          onTap: () => rf.page.back(context, model: null), //rf.page.back(_context),
          child: Icon(Icons.arrow_back_ios, color: Colors.black),
        ),
        elevation: 0,
        backgroundColor: Colors.white,
        title: Text(widget.title ?? config.app.title.toString(),
            style: TextStyle(
              color: Colors.black,
              fontWeight: FontWeight.normal,
            )),
      ),
      backgroundColor: Colors.white,
      body: SingleChildScrollView(
        child: Container(
          child: Column(
            children: <Widget>[
              Container(
                margin: EdgeInsets.only(left: 20, right: 20, bottom: 20, top: 0),
                child: Image(image: AssetImage('assets/images/language.png')),
              ),
              SizedBox(
                height: 10,
              ),
              TextRF("Select Your Language", size: 14),
              SizedBox(
                height: 10,
              ),
              Container(
                //color: Colors.red,
                child: ListView.builder(
                  padding: new EdgeInsets.all(8.0),
                  shrinkWrap: true,
                  reverse: true,
                  itemBuilder: (_, int index) => widget.languages[index],
                  itemCount: widget.languages.length,
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}

class LanguageItems extends StatelessWidget {
  LanguageItems({this.isOnboarding = true, this.text, this.name, this.img, this.locale});

  final bool isOnboarding;
  final String text;
  final String name;
  final String img;
  final String locale;

  List<Widget> languageRow(context) {
/*    Map<String, String> lag = Map();
    lag['en'] = 'English';
    lag['bn'] = 'Bangla';
    lag['sl'] = 'Sinhala';*/
    return <Widget>[
      Expanded(
        child: InkWell(
          onTap: () {
            LanguageRF.loadLanguage(Locale(locale, ''), () {
              if (!isOnboarding) {
                RapidFire.updateGlobalErrorLanguage();
                Navigator.pop(context);
              } else {
                if (!AppOnboardRF.isLanguageLoaded) {
                  AppOnboardRF.isLanguageLoaded = true;
                  rf.page.replace(context, rf.onboard.next());
                }
              }
            });
/*            switch (name) {
              case 'English':
                LanguageRF.loadLanguage(Locale('en', ''), () {
                  if (!isOnboarding) {
                    RapidFire.updateGlobalErrorLanguage();
                    Navigator.pop(context);
                  } else {
                    if (!AppOnboardRF.isLanguageLoaded) {
                      AppOnboardRF.isLanguageLoaded = true;
                      rf.page.replace(context, rf.onboard.next());
                    }
                  }
                });
                break;
              case 'Bangla':
                LanguageRF.loadLanguage(Locale('bn', ''), () {
                  if (!isOnboarding) {
                    RapidFire.updateGlobalErrorLanguage();
                    Navigator.pop(context);
                  } else {
                    if (!AppOnboardRF.isLanguageLoaded) {
                      rf.page.replace(context, rf.onboard.next());
                    }
                  }
                });
                break;
              case 'Sinhala':
                LanguageRF.loadLanguage(Locale('sl', ''), () {
                  if (!isOnboarding) {
                    RapidFire.updateGlobalErrorLanguage();
                    Navigator.pop(context);
                  } else {
                    if (!AppOnboardRF.isLanguageLoaded) {
                      rf.page.replace(context, rf.onboard.next());
                    }
                  }
                });
                break;
            }*/
          },
          child: Row(
            children: <Widget>[
              CircleAvatar(
                radius: 25,
                backgroundImage: AssetImage(img),
                backgroundColor: Colors.transparent,
              ),
              Container(
                width: 15,
              ),
              Expanded(
                child: new Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: <Widget>[
                    new Text(
                      name,
                      style: TextStyle(color: Colors.black87, fontSize: 16, fontWeight: FontWeight.w800),
                    ),
                    SizedBox(
                      height: 5,
                    ),
                    new Text(
                      text,
                      style: TextStyle(color: Colors.black.withAlpha(400), fontSize: 15),
                    ),
                  ],
                ),
                flex: 70,
              ),
              if (rf.pref.getString("lang") != null && rf.pref.getString("lang") == locale)
                Expanded(
                  child: Padding(
                    padding: const EdgeInsets.only(top: 0.0),
                    child: Icon(
                      Icons.check_circle,
                      size: 35,
                      color: Colors.green,
                    ),
                  ),
                  flex: 15,
                )
            ],
          ),
        ),
      ),
    ];
  }

  @override
  Widget build(BuildContext context) {
    return new Container(
      //color: Colors.green,
      margin: const EdgeInsets.symmetric(vertical: 10.0),
      padding: EdgeInsets.all(10),
      child: new Row(
        crossAxisAlignment: CrossAxisAlignment.center,
        children: languageRow(context),
      ),
    );
  }
}
