import 'package:rapidfire/uiux/WidgetsRF.dart';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import '../../../SystemRF.dart';
import '../../../GlobalRF.dart';

class Otp extends StatefulWidget {
  Otp({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _OtpState createState() => _OtpState();
}

class _OtpState extends State<Otp> {
  TextEditingController a = TextEditingController();
  TextEditingController b = TextEditingController();
  TextEditingController c = TextEditingController();
  TextEditingController d = TextEditingController();

  @override
  Widget build(BuildContext context) {
    final height = MediaQuery.of(context).size.height;
    return WillPopScope(
      onWillPop: () {
        Navigator.pop(context);
      },
      child: Scaffold(
        resizeToAvoidBottomInset: false,
        body: Container(color: Colors.white,
          padding: EdgeInsets.symmetric(horizontal: 20),
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.center,
            mainAxisAlignment: MainAxisAlignment.center,
            children: <Widget>[
              Container(
                  margin: EdgeInsets.all(10),
                  child: Image.asset(
                    "assets/images/otp.webp",
                    height: 300,
                  )),
              Text(
                "Give Your OTP",
                style: TextStyle(fontSize: 20),
              ),
              SizedBox(height: 50),
              Expanded(
                flex: 2,
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.start,
                  crossAxisAlignment: CrossAxisAlignment.center,
                  children: <Widget>[
                    Row(
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: <Widget>[
                        Container(
                          width: 50,
                          height: 50,
                          padding: EdgeInsets.only(right: 3, left: 3),
                          decoration: BoxDecoration(
                            boxShadow: [
                              BoxShadow(
                                color: Colors.grey.withOpacity(0.2),
                                spreadRadius: 5,
                                blurRadius: 7,
                                offset: Offset(0, 3), // changes position of shadow
                              ),
                            ],
                            border: Border.all(color: Colors.pink),
                            borderRadius: BorderRadius.all(Radius.circular(5)),
                            color: Colors.white,
                          ),
                          child: TextField(
                              controller: a,
                              maxLength: 1,
                              textAlign: TextAlign.center,
                              keyboardType: TextInputType.number,
                              onChanged: (_) => FocusScope.of(context).nextFocus(),
                              style: TextStyle(fontSize: 20),
                              decoration: InputDecoration(
                                counterText: '',
                                border: InputBorder.none,
                                fillColor: Colors.transparent,
                              )),
                        ),
                        SizedBox(width: 10),
                        Container(
                          width: 50,
                          height: 50,
                          padding: EdgeInsets.only(right: 3, left: 3),
                          decoration: BoxDecoration(
                            boxShadow: [
                              BoxShadow(
                                color: Colors.grey.withOpacity(0.2),
                                spreadRadius: 5,
                                blurRadius: 7,
                                offset: Offset(0, 3), // changes position of shadow
                              ),
                            ],
                            border: Border.all(color: Colors.pink),
                            borderRadius: BorderRadius.all(Radius.circular(5)),
                            color: Colors.white,
                          ),
                          child: TextField(
                              controller: b,
                              maxLength: 1,
                              textAlign: TextAlign.center,
                              keyboardType: TextInputType.number,
                              onChanged: (_) => FocusScope.of(context).nextFocus(),
                              style: TextStyle(fontSize: 20),
                              decoration: InputDecoration(
                                counterText: '',
                                border: InputBorder.none,
                                fillColor: Colors.transparent,
                              )),
                        ),
                        SizedBox(width: 10),
                        Container(
                          width: 50,
                          height: 50,
                          padding: EdgeInsets.only(right: 3, left: 3),
                          decoration: BoxDecoration(
                            boxShadow: [
                              BoxShadow(
                                color: Colors.grey.withOpacity(0.2),
                                spreadRadius: 5,
                                blurRadius: 7,
                                offset: Offset(0, 3), // changes position of shadow
                              ),
                            ],
                            border: Border.all(color: Colors.pink),
                            borderRadius: BorderRadius.all(Radius.circular(5)),
                            color: Colors.white,
                          ),
                          child: TextField(
                              controller: c,
                              maxLength: 1,
                              textAlign: TextAlign.center,
                              keyboardType: TextInputType.number,
                              onChanged: (_) => FocusScope.of(context).nextFocus(),
                              style: TextStyle(fontSize: 20),
                              decoration: InputDecoration(
                                counterText: '',
                                border: InputBorder.none,
                                fillColor: Colors.transparent,
                              )),
                        ),
                        SizedBox(width: 10),
                        Container(
                          width: 50,
                          height: 50,
                          padding: EdgeInsets.only(right: 3, left: 3),
                          decoration: BoxDecoration(
                            boxShadow: [
                              BoxShadow(
                                color: Colors.grey.withOpacity(0.2),
                                spreadRadius: 5,
                                blurRadius: 7,
                                offset: Offset(0, 3), // changes position of shadow
                              ),
                            ],
                            border: Border.all(color: Colors.pink),
                            borderRadius: BorderRadius.all(Radius.circular(5)),
                            color: Colors.white,
                          ),
                          child: TextField(
                              controller: d,
                              maxLength: 1,
                              textAlign: TextAlign.center,
                              keyboardType: TextInputType.number,
                              onChanged: (_) => FocusScope.of(context).unfocus(),
                              style: TextStyle(fontSize: 20),
                              decoration: InputDecoration(
                                counterText: '',
                                border: InputBorder.none,
                                fillColor: Colors.transparent,
                              )),
                        )
                      ],
                    ),
                    SizedBox(height: 80),
                    ButtonRF(
                      color: Colors.pink,
                      buttonType: ButtonType.raised,
                      buttonStyle: ButtonStyleRF.submit,
                      textColor: Colors.white,
                      text: Text(
                        "Confirm",
                        style: TextStyle(fontSize: 18),
                      ),
                      borderRadious: 50,
                      elevation: 0,
                      width: 200,
                      height: 50,
                      onTap: () async {
                        rf.page.replace(context, rf.onboard.next());
                      },
                    ),
                    SizedBox(height: 30),
                  ],
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
