import 'package:rapidfire/uiux/WidgetsRF.dart';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:rapidfire/RapidFire.dart';

import '../../../SystemRF.dart';

class ChangePass extends StatefulWidget {
  ChangePass({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _ChangePassState createState() => _ChangePassState();
}

class _ChangePassState extends State<ChangePass> {
  TextEditingController a = TextEditingController();
  TextEditingController b = TextEditingController();
  TextEditingController c = TextEditingController();
  TextEditingController d = TextEditingController();

  bool _obscureA = true;
  bool _obscureB = true;
  bool _obscureC = true;

  Color _getColor(bool isShowing) {
    if (!isShowing)
      return Colors.blue;
    else
      return Colors.grey;
  }

  @override
  Widget build(BuildContext context) {
    final height = MediaQuery.of(context).size.height;
    return Material(
      child: Container(
        color: Colors.white,
        padding: EdgeInsets.symmetric(horizontal: 20),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          mainAxisAlignment: MainAxisAlignment.start,
          children: <Widget>[
            Container(
                margin: EdgeInsets.all(10),
                child: Center(
                  child: Image.asset(
                    "assets/images/change_pass.webp",
                    height: 200,
                  ),
                )),
            Text("Enter Current Password", style: TextStyle(fontSize: 16)),
            SizedBox(height: 10),
            Container(
              height: 50,
              padding: EdgeInsets.only(right: 3, left: 3),
              decoration: BoxDecoration(
                //                      boxShadow: [
//                        BoxShadow(
//                          color: Colors.grey.withOpacity(0.5),
//                          spreadRadius: 5,
//                          blurRadius: 7,
//                          offset: Offset(0, 3), // changes position of shadow
//                        ),
//                      ],
                border: Border.all(color: Colors.pink),
                borderRadius: BorderRadius.all(Radius.circular(0)),
                color: Colors.white,
              ),
              child: Row(
                children: <Widget>[
                  Expanded(
                    child: TextField(
                        controller: a,
                        maxLength: 11,
                        textAlign: TextAlign.center,
                        keyboardType: TextInputType.text,
                        style: TextStyle(fontSize: 20),
                        obscureText: _obscureA,
                        onChanged: (_) {
                          if (a.text.length == 11) FocusScope.of(context).unfocus();
                        },
                        decoration: InputDecoration(
                          counterText: '',
                          border: InputBorder.none,
                          fillColor: Colors.transparent,
                        )),
                  ),
                  InkWell(
                      onTap: () {
                        _obscureA = !_obscureA;
                        setState(() {});
                      },
                      child: Icon(
                        Icons.remove_red_eye,
                        size: 25,
                        color: _getColor(_obscureA),
                      )),
                  SizedBox(
                    width: 10,
                  )
                ],
              ),
            ),

            SizedBox(height: 40),
            Text(
              "Enter New Password",
              style: TextStyle(fontSize: 16),
            ),
            SizedBox(height: 10),
            Container(
              height: 50,
              padding: EdgeInsets.only(right: 3, left: 3),
              decoration: BoxDecoration(
                boxShadow: [
                  BoxShadow(
                    color: Colors.grey.withOpacity(0.5),
                    spreadRadius: 5,
                    blurRadius: 7,
                    offset: Offset(0, 3), // changes position of shadow
                  ),
                ],
                border: Border.all(color: Colors.pink),
                borderRadius: BorderRadius.all(Radius.circular(0)),
                color: Colors.white,
              ),
              child: Row(
                children: <Widget>[
                  Expanded(
                    child: TextField(
                        controller: b,
                        maxLength: 11,
                        textAlign: TextAlign.center,
                        keyboardType: TextInputType.text,
                        style: TextStyle(fontSize: 20),
                        obscureText: _obscureB,
                        onChanged: (_) {
                          if (a.text.length == 11) FocusScope.of(context).unfocus();
                        },
                        decoration: InputDecoration(
                          counterText: '',
                          border: InputBorder.none,
                          fillColor: Colors.transparent,
                        )),
                  ),
                  InkWell(
                      onTap: () {
                        _obscureB = !_obscureB;
                        setState(() {});
                      },
                      child: Icon(
                        Icons.remove_red_eye,
                        size: 25,
                        color: _getColor(_obscureB),
                      )),
                  SizedBox(
                    width: 10,
                  )
                ],
              ),
            ),
            SizedBox(height: 20),
            Text(
              "Confirm New Password",
              style: TextStyle(fontSize: 16),
            ),
            SizedBox(height: 10),
            Container(
              height: 50,
              padding: EdgeInsets.only(right: 3, left: 3),
              decoration: BoxDecoration(
                boxShadow: [
                  BoxShadow(
                    color: Colors.grey.withOpacity(0.5),
                    spreadRadius: 5,
                    blurRadius: 7,
                    offset: Offset(0, 3), // changes position of shadow
                  ),
                ],
                border: Border.all(color: Colors.pink),
                borderRadius: BorderRadius.all(Radius.circular(0)),
                color: Colors.white,
              ),
              child: Row(
                children: <Widget>[
                  Expanded(
                    child: TextField(
                        controller: c,
                        maxLength: 11,
                        textAlign: TextAlign.center,
                        keyboardType: TextInputType.text,
                        style: TextStyle(fontSize: 20),
                        obscureText: _obscureC,
                        onChanged: (_) {
                          if (a.text.length == 11) FocusScope.of(context).unfocus();
                        },
                        decoration: InputDecoration(
                          counterText: '',
                          border: InputBorder.none,
                          fillColor: Colors.transparent,
                        )),
                  ),
                  InkWell(
                      onTap: () {
                        _obscureC = !_obscureC;
                        setState(() {});
                      },
                      child: Icon(
                        Icons.remove_red_eye,
                        size: 25,
                        color: _getColor(_obscureC),
                      )),
                  SizedBox(
                    width: 10,
                  )
                ],
              ),
            ),
            Expanded(
              child: SizedBox(),
            ),
            Center(
              child: Container(
                color: Colors.transparent,
                width: 480,
                child: Column(
                  children: <Widget>[
                    //Expanded(child: SizedBox(),),
                    ButtonRF(
                      color: Colors.pink,
                      buttonType: ButtonType.raised,
                      buttonStyle: ButtonStyleRF.submit,
                      textColor: Colors.white,
                      text: Text(
                        "Confirm",
                        style: TextStyle(fontSize: 18),
                      ),
                      borderRadious: 50,
                      elevation: 0,
                      width: 200,
                      height: 50,
                      onTap: () async {
                        if (b.text == c.text) {
                          rf.msg(context, "This Feature will be avilable soon");
                        } else {
                          rf.msg(context, "New Paswword not matched with each other");
                        }
                      },
                    ),
                  ],
                ),
              ),
            ),
            SizedBox(height: 30),
            //SizedBox(height: 30),
          ],
        ),
      ),
    );
  }
}
