import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:rapidfire/RapidFire.dart';
import 'package:rapidfire/uiux/swl/sweetalert.dart';

//              return AlertRF(
//                  context: context,
//                  title: 'Confirm',
//                  icon: Icons.error,
//                  msg: 'Save change pending, do you want to quite anyway?',
//                  confirmText: 'DO NOT SAVE',
//                  onConfirm: (value) {
//                    if (value) Navigator.pop(context);
//                  }).show();

class AlertRF_RND extends StatefulWidget {
  Function onConfirm;

  @override
  _AlertRF_RNDState createState() => _AlertRF_RNDState();

  AlertRF_RND({this.onConfirm});
}

class _AlertRF_RNDState extends State<AlertRF_RND> {
  @override
  Widget build(BuildContext context) {
    return AlertDialog(
      title: Row(children: [
        Image.network(
          'https://flutter-examples.com/wp-content/uploads/2019/12/android_icon.png',
          width: 50,
          height: 50,
          fit: BoxFit.contain,
        ),
        TextRF('  Alert Dialog Title. ')
      ]),
      content: TextRF("Are You Sure Want To Proceed?"),
      actions: <Widget>[
        FlatButton(
          child: TextRF("YES"),
          onPressed: () {
            widget.onConfirm(true);
            //Put your code here which you want to execute on Yes button click.
            Navigator.of(context).pop(true);
          },
        ),
        FlatButton(
          child: TextRF("CANCEL"),
          onPressed: () {
            widget.onConfirm(false);
            //Put your code here which you want to execute on Cancel button click.
            Navigator.of(context).pop(false);
          },
        ),
      ],
    );
  }
}

class AlertRF {
  BuildContext context;
  String title;
  IconData icon;
  String msg;
  String confirmText;
  String cancelText;
  Function onConfirm;

  AlertRF(
      {@required this.context,
      this.title,
      @required this.msg,
      this.icon,
      this.confirmText = 'OK',
      this.cancelText = 'CANCEL',
      this.onConfirm});

  show() async {
    return await showDialog(
      context: context,
      builder: (BuildContext context) {
        return Dialog(
          shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.circular(20),
          ),
          elevation: 0,
          backgroundColor: Colors.transparent,
          child: contentBox(context),
        );
      },
    );
  }

  contentBox(context) {
    return Stack(
      children: <Widget>[
        BackdropFilter(
          filter: ImageFilter.blur(sigmaX: 2, sigmaY: 2),
          child: Container(
            padding: EdgeInsets.only(
                left: Constants.padding,
                top: Constants.avatarRadius,
                right: Constants.padding,
                bottom: Constants.padding),
            margin: EdgeInsets.only(top: Constants.avatarRadius),
            decoration: BoxDecoration(
                shape: BoxShape.rectangle,
                color: Colors.white,
                borderRadius: BorderRadius.circular(Constants.padding),
                boxShadow: [
                  BoxShadow(
                      color: Colors.black.withOpacity(0.4), offset: Offset(0, 0), spreadRadius: 0, blurRadius: 15),
                ]),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: <Widget>[
                TextRF(
                  title,
                  languageSource: "System",
                  style: TextStyle(fontSize: 22, fontWeight: FontWeight.w600),
                ),
                SizedBox(
                  height: 15,
                ),
                Center(
                  child: TextRF(
                    msg,
                    languageSource: "System",
                    style: TextStyle(fontSize: 18),
                    align: TextAlign.center,
                  ),
                ),
                SizedBox(
                  height: 35,
                ),
                Align(
                  alignment: Alignment.bottomRight,
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.end,
                    children: [
                      InkWell(
                          onTap: () {
                            onConfirm(true);
                            Navigator.of(context).pop(true);
                          },
                          child: Container(
                            width: 100,
                            margin: EdgeInsets.all(8),
                            padding: EdgeInsets.all(8),
                            decoration: BoxDecoration(
                              shape: BoxShape.rectangle,
                              color: Colors.blue.withOpacity(0.3),
                              borderRadius: BorderRadius.circular(5),
                            ),
                            child: Center(
                              child: TextRF(
                                confirmText,
                                languageSource: "System",
                                style: TextStyle(fontSize: 15),
                              ),
                            ),
                          )),
                      InkWell(
                          onTap: () {
                            onConfirm(false);
                            Navigator.of(context).pop(false);
                          },
                          child: Container(
                            width: 100,
                            margin: EdgeInsets.all(8),
                            padding: EdgeInsets.all(8),
                            decoration: BoxDecoration(
                              shape: BoxShape.rectangle,
                              color: Colors.red.withOpacity(0.3),
                              borderRadius: BorderRadius.circular(5),
                            ),
                            child: Center(
                              child: TextRF(
                                cancelText,
                                languageSource: "System",
                                style: TextStyle(fontSize: 15),
                              ),
                            ),
                          )),
                    ],
                  ),
                ),
              ],
            ),
          ),
        ),
        Positioned(
          left: Constants.padding,
          right: Constants.padding,
          child: CircleAvatar(
            backgroundColor: Colors.white,
            radius: Constants.avatarRadius,
            child: ClipRRect(
              borderRadius: BorderRadius.all(Radius.circular(Constants.avatarRadius)),
              child: Icon(
                icon,
                size: 64,
                color: Colors.deepOrange,
              ),
            ),
          ),
        ),
      ],
    );
  }

  static sh(BuildContext context, Function fn) async {
    return await showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          title: const Text("Confirm"),
          content: const Text("Are you sure you wish to delete this item?"),
          actions: <Widget>[
            FlatButton(
                onPressed: () {
                  Navigator.of(context).pop(true);
                  fn(true);
                },
                child: const Text("DELETE")),
            FlatButton(
              onPressed: () {
                Navigator.of(context).pop(false);
                fn(false);
              },
              child: const Text("CANCEL"),
            ),
          ],
        );
      },
    );
  }

  static showSA(BuildContext context, String msg, Function onConfirm) {
    SweetAlert.show(context, title: msg, style: SweetAlertStyle.confirm, showCancelButton: true,
        onPress: (bool isConfirm) {
      if (isConfirm) {
        //SweetAlert.show(context, style: SweetAlertStyle.success, title: "Success");
        // return false to keep dialog
        return onConfirm(isConfirm);
      }
      return onConfirm(isConfirm);
    });
  }
}

class Constants {
  Constants._();
  static const double padding = 20;
  static const double avatarRadius = 45;
}

class abc extends StatefulWidget {
  @override
  _abcState createState() => _abcState();
}

class _abcState extends State<abc> {
  @override
  Widget build(BuildContext context) {}
}
