import 'package:flutter/material.dart';
import 'package:flutter_placeholder_textlines/placeholder_lines.dart';

enum PlaceholderTypeRF {
  Inline,
  PageView,
  ListView,
}

class PlaceholderRF extends StatefulWidget {
  final PlaceholderTypeRF type;
  final int items;
  final int lines;
  final double lineHeight;
  final Color lineColor;
  final TextAlign align;
  final double borderRadius;
  final Color backColor;
  final Border border;
  final double height;

  PlaceholderRF({
    Key key,
    this.type = PlaceholderTypeRF.Inline,
    this.items = 2,
    this.lines = 4,
    this.lineHeight = 14,
    this.lineColor = Colors.grey,
    this.align = TextAlign.left,
    this.backColor = Colors.black12,
    this.borderRadius = 10,
    this.border,
    this.height = 40,
  }) : super(key: key);

  @override
  _PlaceholderRFState createState() => _PlaceholderRFState();
}

class _PlaceholderRFState extends State<PlaceholderRF> {
  List ph = <Widget>[];

  @override
  Widget build(BuildContext context) {
    if (widget.type == PlaceholderTypeRF.PageView) {
      return page();
    } else if (widget.type == PlaceholderTypeRF.ListView) {
      return list();
    } else if (widget.type == PlaceholderTypeRF.Inline) return line(widget.height);
  }

  List<Widget> addItems([PlaceholderTypeRF type]) {
    EdgeInsets ei;
    if (type == PlaceholderTypeRF.PageView) {
      ei = EdgeInsets.only(right: 10);
    } else if (type == PlaceholderTypeRF.ListView) {
      ei = EdgeInsets.only(bottom: 10);
    }

    for (int i = 0; i <= widget.items; i++) {
      ph.add(
        Container(
          padding: EdgeInsets.all(10),
          margin: ei,
          child: PlaceholderLines(
            count: widget.lines,
            animate: true,
            align: widget.align,
            lineHeight: widget.lineHeight,
            color: widget.lineColor,
          ),
          decoration: BoxDecoration(
            border: widget.border,
            borderRadius: BorderRadius.all(Radius.circular(widget.borderRadius)),
            color: widget.backColor ?? Colors.white,
          ),
        ),
      );
    }
    return ph;
  }

  page() => PageView(
        controller: PageController(initialPage: 0, viewportFraction: 0.8),
        children: addItems(PlaceholderTypeRF.PageView),
      );

  list() => ListView(
        children: addItems(PlaceholderTypeRF.ListView),
      );

  line(height) => Container(
        padding: EdgeInsets.all(10),
        height: height,
        child: PlaceholderLines(
          count: widget.lines,
          animate: true,
          align: widget.align,
          lineHeight: widget.lineHeight,
          color: widget.lineColor,
        ),
        decoration: BoxDecoration(
          border: widget.border,
          borderRadius: BorderRadius.all(Radius.circular(widget.borderRadius)),
          color: widget.backColor,
        ),
      );
}
