import 'package:flutter/material.dart';
import '../Extensions.dart';
import '../GlobalScopeRF.dart';
//import 'package:sizer/sizer.dart';

//enum TemplateNameRF { material, cupertino, modern, classic }
enum TemplateNameRF { material, cupertino, modern, classic }

class TemplateRF {
  TemplateNameRF name;
  String version;
  WidgetStyleRF style;
  dynamic directives;

  TemplateRF(
    this.name, {
    this.version,
    this.style,
    this.directives,
  }) {
    if (this.name == null) this.name = TemplateNameRF.modern;
  }

  static TemplateRF get([TemplateRF template]) {
    if (template == null) return Libs.config.app.template ?? TemplateRF(TemplateNameRF.modern);

    if (template is TemplateRF) return template;

//    if (template is TemplateNameRF) {
//      return TemplateRF(template);
//    }
//
//    if (template is List) {
//      if (template.length == 0) {
//        return TemplateRF(TemplateNameRF.modern);
//      } else if (template.length == 1) {
//        return TemplateRF(template[0]);
//      } else if (template.length == 2) {
//        return TemplateRF(template[0], template[1]);
//      }
//    }
  }
}

class AppStyles {
  AppThemeStyleRF theme = AppThemeStyleRF();
  ColorRF color = ColorRF();
  GradientRF gradient = GradientRF();
  ShadowRF shadow = ShadowRF();
}

class WidgetStyleRF {
  static AppThemeStyleRF theme = AppThemeStyleRF();
  static ColorRF colors = ColorRF();
  static GradientRF gradients = GradientRF();
  static ShadowRF shadows = ShadowRF();

  double height;
  double width;
  Color textColor;
  double fontSize;
  String fontFamily;
  FontWeight fontWeight;
  Color borderColor;
  Border border;
  double borderWidth;
  double borderRadius;
  Color backColor;
  Widget placeholder;
  Color placeholderBackColor;
  Border placeholderBorder;
  int placeholderLines;
  Color placeholderLineColor;
  double placeholderLineHeight;
  bool placeholderVisible;
  double placeholderRadius;
  List<BoxShadow> shadow;
  List<Widget> backgroundPositionedImages;
  TextStyle textStyle;
  Color hintColor;
  bool visible;
  InputDecoration inputDecoration;
  InputBorder inputBorder;
  Decoration decoration;
  EdgeInsets padding;
  EdgeInsets margin;
  Icon icon;
  IconData icons;
  Color iconColor;
  Icon iconAlt;
  IconData iconsAlt;
  Color iconColorAlt;

  WidgetStyleRF({
    this.height,
    this.width,
    this.padding,
    this.margin,
    this.decoration,
    this.inputDecoration,
    this.textStyle,
    this.textColor = Colors.black,
    this.fontSize = 16.0,
    this.fontFamily,
    this.fontWeight = FontWeight.normal,
    this.borderColor = Colors.white,
    this.border,
    this.borderWidth,
    this.borderRadius,
    this.backColor,
    this.backgroundPositionedImages,
    this.shadow,
    this.hintColor,
    this.visible,
    this.icon,
    this.icons,
    this.iconColor,
    this.iconAlt,
    this.iconsAlt,
    this.iconColorAlt,
    this.placeholder,
    this.placeholderBackColor,
    this.placeholderBorder,
    this.placeholderLines,
    this.placeholderRadius,
    this.placeholderLineColor,
    this.inputBorder,
    this.placeholderLineHeight,
    this.placeholderVisible = true,
  });
}

class AppThemeStyleRF {
  @override
  bool operator +(other) {
    // compare this to other
  }

  var clientTheme = Libs.config.app.template;
  var clientStyle = Libs.config.app.theme;

  TextStyle appTitle([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: clientStyle?.appTitle?.textColor ?? Colors.pink[500],
          fontSize: clientStyle?.appTitle?.fontSize ?? 35,
          fontWeight: clientStyle?.appTitle?.fontWeight ?? FontWeight.bold,
          fontFamily: clientStyle?.appTitle?.fontFamily ?? 'Berlin Sans FB Demi Bold',
          //letterSpacing: 1,
          decoration: TextDecoration.none,
          shadows: [ShadowRF.shadow1PX],
        );
    }
  }

  TextStyle appSubTitle([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: clientStyle?.appSubTitle?.textColor ?? Colors.white60,
          fontSize: clientStyle?.appSubTitle?.fontSize ?? 15,
          fontWeight: clientStyle?.appSubTitle?.fontWeight ?? FontWeight.bold,
          fontFamily: clientStyle?.appSubTitle?.fontFamily ?? 'Berlin Sans FB Demi Bold',
          decoration: TextDecoration.none,
        );
    }
  }

  TextStyle pageTitle([TemplateRF template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: template?.style?.textColor ?? clientStyle?.pageTitle?.textColor ?? Colors.black54,
          fontSize: template?.style?.fontSize ?? clientStyle?.pageTitle?.fontSize ?? 20,
          fontWeight: clientStyle?.pageTitle?.fontWeight ?? FontWeight.bold,
          fontFamily: clientStyle?.pageTitle?.fontFamily ?? 'Roboto',
          letterSpacing: 1,
          decoration: TextDecoration.none,
        );
    }
  }

  TextStyle pageSubTitle([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color:
              template?.style?.textColor ?? clientStyle?.pageSubTitle?.textColor ?? Colors.black54,
          fontSize: template?.style?.fontSize ?? clientStyle?.pageSubTitle?.fontSize ?? 18,
          fontWeight: clientStyle?.pageSubTitle?.fontWeight ?? FontWeight.bold,
          fontFamily: clientStyle?.pageSubTitle?.fontFamily ?? 'Raleway',
          letterSpacing: 1,
          decoration: TextDecoration.none,
        );
    }
  }

  TextStyle pageSegmentTitle([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: clientStyle?.pageSubTitle?.textColor ?? Colors.black,
          fontSize: clientStyle?.pageSubTitle?.fontSize ?? 18,
          fontWeight: clientStyle?.pageSubTitle?.fontWeight ?? FontWeight.bold,
          fontFamily: clientStyle?.pageSubTitle?.fontFamily ?? 'Roboto',
          letterSpacing: 1,
          decoration: TextDecoration.none,
        );
    }
  }

  TextStyle label([dynamic template]) {
    switch (TemplateRF.get(template).name) {
      case TemplateNameRF.modern:
        return TextStyle(
          color: clientStyle?.pageSubTitle?.textColor ?? Colors.black,
          fontSize: clientStyle?.pageSubTitle?.fontSize ?? 14,
          fontWeight: clientStyle?.pageSubTitle?.fontWeight ?? FontWeight.bold,
          fontFamily: clientStyle?.pageSubTitle?.fontFamily ?? 'Roboto',
          letterSpacing: 1,
          decoration: TextDecoration.none,
        );
    }
  }
}

class ThemeRF {
  WidgetStyleRF widgets;
  Color color;

  //FontFace font;
  WidgetStyleRF appTitle;
  WidgetStyleRF appSubTitle;
  WidgetStyleRF pageTitle;
  WidgetStyleRF pageSubTitle;
  WidgetStyleRF pageSegmentTitle;
  WidgetStyleRF pageSegmentSubTitle;
  WidgetStyleRF label;
  WidgetStyleRF error;
  WidgetStyleRF info;
  WidgetStyleRF warning;
  WidgetStyleRF headline1;
  WidgetStyleRF headline6;
  WidgetStyleRF button1;
  WidgetStyleRF button2;
  WidgetStyleRF button3;
  WidgetStyleRF controlBackground;
  WidgetStyleRF pageBackground;

  ThemeRF({
    this.widgets,
    this.color, //  this.font,
    this.appTitle,
    this.appSubTitle,
    this.pageTitle,
    this.pageSubTitle,
    this.pageSegmentTitle,
    this.pageSegmentSubTitle,
    this.label,
    this.error,
    this.info,
    this.warning,
    this.headline1,
    this.headline6,
    this.button1,
    this.button2,
    this.button3,
    this.controlBackground,
    this.pageBackground,
  });
}

class ColorRF {
  var danger;
}

class ShadowRF {
  static var shadow1PX = Shadow(
    blurRadius: 1.0,
    color: Colors.black45,
    offset: Offset(1.0, 1.0),
  );
}

class GradientRF {
  topLightBottomDark(String colorTop, String colorBottom) {
    var _colorTop = colorTop.toColor;
    var _colorBottom = colorBottom.toColor;
    return BoxDecoration(
      gradient: LinearGradient(
        begin: Alignment.topLeft,
        end: Alignment.bottomRight,
        colors: [
          Color.fromRGBO(_colorTop.red, _colorTop.green, _colorTop.blue, 1.0),
          Color.fromRGBO(_colorBottom.red, _colorBottom.green, _colorBottom.blue, 1.0),
        ],
        tileMode: TileMode.repeated,
      ),
    );
  }

  lefttLightRighrDark(String colorTop, String colorBottom) {
    var _colorTop = colorTop.toColor;
    var _colorBottom = colorBottom.toColor;
    return BoxDecoration(
      gradient: LinearGradient(
        begin: Alignment.centerLeft,
        end: Alignment.centerRight,
        colors: [
          Color.fromRGBO(_colorTop.red, _colorTop.green, _colorTop.blue, 1.0),
          Color.fromRGBO(_colorBottom.red, _colorBottom.green, _colorBottom.blue, 1.0),
        ],
        tileMode: TileMode.repeated,
      ),
    );
  }
}

//44, 72, 171, 1.0 //234, 43, 109, 1.0
