import 'package:flutter/material.dart';
import 'package:rapidfire/scorm/ScormRF.dart';

class TableRF extends StatefulWidget {
  List<String> columns;

  @override
  _TableRFState createState() => _TableRFState();

  TableRF(this.columns);
}

class _TableRFState extends State<TableRF> {
  var ts = TextStyle(fontSize: 14, color: Colors.black, fontWeight: FontWeight.bold, decoration: TextDecoration.none);

  @override
  Widget build(BuildContext context) {
    return Table(
      columnWidths: {
        0: FlexColumnWidth(7),
        1: FlexColumnWidth(28),
        2: FlexColumnWidth(25),
        3: FlexColumnWidth(25),
        4: FlexColumnWidth(15)
      },
      border: TableBorder.all(color: Colors.black12, width: 2),
      children: getTable(),
    );
  }

  getTable() {
    List<Widget> headers = [];
    List<TableRow> items = [];
    for (var item in widget.columns) {
      headers.add(
        Column(
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [Padding(padding: const EdgeInsets.all(4.0), child: Text(item, style: ts))],
        ),
      );
    }

    items.add(TableRow(children: headers));

    var data = scorm.coreCMI.InteractionsCMI;

    for (var item in data) {
      items.add(TableRow(children: [
        Column(crossAxisAlignment: CrossAxisAlignment.center, children: [
          Padding(
            padding: const EdgeInsets.all(4.0),
            child: Text(item.interaction ?? 'e', style: ts),
          )
        ]),
        Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
          Padding(
            padding: const EdgeInsets.all(4.0),
            child: Text(item.id ?? 'e', style: ts),
          )
        ]),
        Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
          Padding(
            padding: const EdgeInsets.all(4.0),
            child: Text(item.student_response ?? 'e', style: ts),
          )
        ]),
        Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
          Padding(
            padding: const EdgeInsets.all(4.0),
            child: Text(item.correct_responses_pattern ?? 'e', style: ts),
          )
        ]),
        Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
          Padding(
            padding: const EdgeInsets.all(4.0),
            child: Text(item.result ?? 'e', style: ts),
          )
        ]),
      ]));
    }
    return items;
  }
}
