import 'package:flutter/material.dart';

import '../Dynamic.dart';

class TextFormFieldRF extends StatefulWidget {
  const TextFormFieldRF({
    this.fieldKey,
    this.bind,
    this.model,
    this.maxLength,
    this.hintText,
    this.hint,
    this.caption,
    this.onSaved,
    this.validator,
    this.onFieldSubmitted,
  });

  final Key fieldKey;

  final dynamic bind;
  final dynamic model;
  final int maxLength;
  final String hintText;
  final String hint;
  final String caption;
  final FormFieldSetter<String> onSaved;
  final FormFieldValidator<String> validator;
  final ValueChanged<String> onFieldSubmitted;

  @override
  _TextFormFieldRF createState() => _TextFormFieldRF();
}

class _TextFormFieldRF extends State<TextFormFieldRF> {
  final _controller = TextEditingController();
  bool _obscureText = true;

  @override
  Widget build(BuildContext context) {

    var tbValue = "";
    var model;
    var modelField;
    if (widget.bind != null) {
      model = widget.bind[0];
      modelField = widget.bind[1].toString();
      tbValue = Dynamic(model).get(modelField).toString();
    }
    var _TextFormField = TextFormField(
      // key: widget.fieldKey,
      controller: _controller,
      obscureText: _obscureText,
      maxLength: widget.maxLength ?? 8,
      // if not provided by the user, then it is 8
      onSaved: widget.onSaved,
      onChanged: (input) {
        Dynamic(model).set(modelField, input);
      },
      validator: widget.validator,
      onFieldSubmitted: widget.onFieldSubmitted,
      decoration: InputDecoration(
        border: const UnderlineInputBorder(),
        filled: true,
        hintText: widget.hintText,
        labelText: widget.hint,
        helperText: widget.caption,
        suffixIcon: GestureDetector(
          onTap: () {
            setState(() {
              _obscureText = !_obscureText;
            });
          },
          child: Icon(_obscureText ? Icons.visibility : Icons.visibility_off),
        ),
      ),
    );
    //widget.bind = null;
    // _controller.text = tbValue;
    return _TextFormField;
  }
}
