import 'package:flutter/material.dart';
import 'package:rapidfire/uiux/WidgetsRF.dart';

abstract class IPageRF {
  AppBar customAppBar(
      PageType pageType, BuildContext context, Object model, dynamic pageData);
}

abstract class IPageOutlineRF {
  OutlineRF customOutline({Function onDrawerItemClick});
}

abstract class IDrawerRF {
  Widget customDrawer();
}

abstract class IOnboardRF {
  AppOnboardRF customOnboard();
}

abstract class IStyleRF {
  WidgetStyleRF customStyle(
    BuildContext context,
    Type widgetType,
    dynamic pageData,
    bool showPlaceholder,
  );
}

abstract class ITextRFStyle {
  StyleTextRF textRFStyle();
}

abstract class ITextFieldRFStyle {
  StyleTextRF textFieldRFStyle();
}

abstract class IContainerRFStyle {
  StyleContainerRF containerRFStyle();
}

enum ThemeDataTypeRF { light, dark }

abstract class IThemeDataRF {
  ThemeData customThemeData(ThemeDataTypeRF themeType);
}

class StyleTextRF {
  double fontSize;
  FontWeight fontWeight;
  Color color;
  TextStyle textStyle;

  StyleTextRF({this.fontSize, this.fontWeight, this.color, this.textStyle});
}

class StyleContainerRF {
  final AlignmentGeometry alignment;
  final EdgeInsetsGeometry padding;
  final EdgeInsetsGeometry margin;
  final int height;
  final Decoration decoration;

  StyleContainerRF({
    this.alignment,
    this.padding,
    this.margin,
    this.height,
    this.decoration,
  });
}
