import 'package:flutter/material.dart';
import 'dart:io';

class AnimatedContainerRF extends StatefulWidget {
  bool visibility;
  int startDelay;
  int endDelay;
  Widget child;

  @override
  _AnimatedContainerRFState createState() => _AnimatedContainerRFState();

  AnimatedContainerRF({this.visibility, this.child, this.startDelay = 50, this.endDelay = 500});
}

class _AnimatedContainerRFState extends State<AnimatedContainerRF> {
  var basePanelVisible = false;
  var animationVisible = false;

  Future<bool> waitDelayEffect(bool status) async {
    sleep(Duration(microseconds: widget.startDelay));
    return status;
  }

  @override
  Widget build(BuildContext context) {
    if (widget.visibility) {
      basePanelVisible = widget.visibility;
    }
    animationVisible = widget.visibility;
    return Visibility(
      visible: basePanelVisible,
      child: FutureBuilder(
        future: waitDelayEffect(animationVisible),
        builder: (_, ss) {
          animationVisible = ss.data ?? false;
          return AnimatedOpacity(
            opacity: animationVisible ? 1.0 : 0.0,
            //curve: Curves.easeInOut,
            duration: Duration(milliseconds: widget.endDelay),
            onEnd: () {
              if (animationVisible == false) {
                basePanelVisible = false;
                animationVisible = false;
              }
              setState(() {});
            },
            child: widget.child,
          );
        },
      ),
    );
  }
}
