import 'package:flutter/material.dart';

class TabRF extends StatefulWidget {
  final List<Widget> tabs;
  final List<Widget> items;
  final Function onTap;
  final Widget tabBuilder;
  final MainAxisAlignment alignment;
  final double gap;
  final double bottomBorder;
  final Color borderColor;
  final bool fireItemTap;
  final TabControllerRF controller;

  const TabRF({
    Key key,
    this.tabs,
    this.items,
    this.onTap,
    this.tabBuilder,
    this.alignment = MainAxisAlignment.center,
    this.gap = 15,
    this.bottomBorder = 2,
    this.borderColor = Colors.red,
    this.fireItemTap = true,
    this.controller,
  }) : super(key: key);

  @override
  _TabRFState createState() => _TabRFState();
}

class _TabRFState extends State<TabRF> {
  int activeTab = 0;

  List<Widget> tabs() {
    List<Widget> wiz = [];
    for (int i = 0; i < widget.tabs.length; i++) {
      var tab = InkWell(
        onTap: () {
          activeTab = i;
          Widget _currentItem = widget.items[i];
          if (widget.onTap != null) widget.onTap(i, _currentItem);
        },
        child: Container(
          decoration: BoxDecoration(
            border: Border(
              bottom: BorderSide(
                width: widget.bottomBorder,
                color: activeTab == i ? widget.borderColor : Colors.transparent,
              ),
            ),
          ),
          child: Padding(
            padding: const EdgeInsets.all(0),
            child: Center(
              child: widget.tabs[i],
            ),
          ),
        ),
      );
      wiz.add(tab);
      wiz.add(SizedBox(width: widget.gap));
    }
    return wiz;
  }

  @override
  void initState() {
    if (widget.fireItemTap) {
      WidgetsBinding.instance.addPostFrameCallback((_) {
        (tabs().first as InkWell).onTap();
      });
    }
    // widget.controller.refresh = () {
    //   (tabs()[activeTab] as InkWell).onTap();
    // };
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      child: Row(
        mainAxisAlignment: widget.alignment,
        children: tabs(),
      ),
    );
  }
}

class TabControllerRF {
  Function refresh;
}
