import 'dart:io';
import 'dart:typed_data';

import 'package:flutter/services.dart';
import 'package:path_provider/path_provider.dart';

class FileRF {
  //from asset or file path
  static toByteData(String fileName, [bool isAsset = false]) async {
    ByteData data;
    if (!isAsset) {
      File file = File('$fileName');
      Uint8List bytes = file.readAsBytesSync();
      data = ByteData.view(bytes.buffer);
    } else {
      data = await rootBundle.load('assets/$fileName');
    }
    return data;
  }

  Future<File> assetToExternalStorage(String filename) async {
    ByteData byteData = await rootBundle.load('assets/$filename');
    // this creates the file image
    Directory appDir = await getApplicationDocumentsDirectory();
    var _path = appDir.path + '/www';
    File file = await File('$_path/$filename').create(recursive: true);
    // copies data byte by byte
    await file.writeAsBytes(byteData.buffer.asUint8List(byteData.offsetInBytes, byteData.lengthInBytes));
  }
}