import 'dart:async';
import 'package:flutter/widgets.dart';
import 'package:flutter_local_notifications/flutter_local_notifications.dart';
import 'package:progress_dialog/progress_dialog.dart';
import 'package:workmanager/workmanager.dart';
import '../BGSyncSMain.dart';
import '../BGHelperDB.dart';

class ApiX {
  ProgressDialog pr;

  sync(BuildContext context) async {
    resetService('age');
    pr = ProgressDialog(context, type: ProgressDialogType.Download, isDismissible: true);
    await pr.show();
    //startWithService('syncService', syncDispatcher);
    onServiceComplete('age');
  }

  onServiceComplete(String serviceName) async {
    Timer.periodic(const Duration(seconds: 3), (timer) async {
      var value = await watchServiceCompleted(serviceName);
      if (value == 1) {
        await pr.hide();
        timer.cancel();
      }
    });
  }
}

startWithService(String jobName, Function callback) async {
  WidgetsFlutterBinding.ensureInitialized();
  await Workmanager.initialize(callback, isInDebugMode: false);
  await Workmanager.registerOneOffTask("1", jobName);
}

final dbHelper = BGHelperDB.instance;

watchServiceCompleted(String serviceName) async {
  var ret = await dbHelper.queryAllRows();
  return ret.first[serviceName];
}

notifyServiceCompleted() async {
  Map<String, dynamic> row = {BGHelperDB.jobId: 1, BGHelperDB.jobCompleteStatus: 1};
  await dbHelper.updateCompleteStatus('row', 1);
}

resetService(String serviceName) async {
  Map<String, dynamic> row = {BGHelperDB.jobId: 1, BGHelperDB.jobCompleteStatus: 0};
  await dbHelper.updateCompleteStatus('row', 0);
}
