import 'dart:async';

import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

class ProfileMaster extends StatefulWidget {
  final String appBarTitle;
  final dynamic profile;

  ProfileMaster(this.profile, this.appBarTitle);

  @override
  State<StatefulWidget> createState() {
    return ProfileMasterState(this.profile);
  }
}

class ProfileMasterState extends State<ProfileMaster> {
  static var _priorities = ['Android', 'IOS', 'Windows', 'Others'];


  String appBarTitle;
  dynamic profile;



  ProfileMasterState(this.profile);

  @override
  void initState() {}

  SetStateFromUI() {
    FocusScope.of(context).requestFocus(new FocusNode());
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
        onWillPop: () {
          // Write some code to control things, when user press Back navigation button in device navigationBar
          moveToLastScreen();
        },
        child: Scaffold(
          backgroundColor: Colors.white,
          body: NestedScrollView(
            headerSliverBuilder:
                (BuildContext context, bool innerBoxIsScrolled) {
              return <Widget>[
                SliverAppBar(
                  expandedHeight: 200.0,
                  floating: true,
                  backgroundColor: Colors.white,
                  actions: <Widget>[
                    InkWell(
                      onTap: () {

                      },
                      child: Container(
                        margin: const EdgeInsets.only(right: 10),
                        child: Icon(
                          Icons.my_location,
                          color: Colors.black54,
                        ),
                      ),
                    )
                  ],
                  pinned: true,
                  elevation: 0,
                  flexibleSpace: FlexibleSpaceBar(
                      centerTitle: false,
                      title: Text("Profile",
                          style: TextStyle(
                            color: Colors.teal,
                            fontSize: 16.0,
                          )),
                      background: Image.asset(
                        "images/profile_banner.png",
                        fit: BoxFit.contain,
                      )),
                ),
              ];
            },
            body: Center(
              child: Padding(
                padding: EdgeInsets.only(top: 15.0, left: 10.0, right: 10.0),
                child: ListView(
                  children: <Widget>[
                  Text('jhhjgj'),

                    // Fifth Element
                    Padding(
                      padding: EdgeInsets.only(top: 15.0, bottom: 15.0),
                      child: Row(
                        children: <Widget>[
                          Expanded(
                            child: Container(
                              height: 45,
                              child: RaisedButton(
                                color: Colors.green,
                                textColor: Colors.white,
                                child: Text(
                                  'Save',
                                  textScaleFactor: 1.5,
                                ),
                                onPressed: () {
                                  setState(() {
                                    debugPrint("Save button clicked");
                                    _save();
                                  });
                                },
                              ),
                            ),
                          ),
                          Container(
                            width: 10.0,
                          ),
                          Expanded(
                            child: Container(
                              height: 45,
                              child: RaisedButton(
                                color: Colors.blue,
                                textColor: Colors.white,
                                child: Text(
                                  'Delete',
                                  textScaleFactor: 1.5,
                                ),
                                onPressed: () {
                                  setState(() {
                                    debugPrint("Delete button clicked");
                                    //_delete();
                                  });
                                },
                              ),
                            ),
                          ),
                        ],
                      ),
                    ),
                  ],
                ),
              ),
            ),
          ),
        ));
  }

  void moveToLastScreen() {
    Navigator.pop(context, true);
  }

  // Save data to database
  void _save() async {
    moveToLastScreen();
    profile.DataCollectionDate =
        DateFormat.yMMMd().format(DateTime.now()).toString();
    int result;
    /*   if (profile.VolunteerId != null) {
      // Case 1: Update operation
      result = await helper.updateNote(
          'Profile', profile.toMap(), "VolunteerId", profile.VolunteerId);
    } else {*/
    // Case 2: Insert Operation
   // result = await helper.insert('profile', profile.toMap());
    //}

    if (result != 0) {
      // Success
      _showAlertDialog('Status', 'Profile Saved Successfully');
    } else {
      // Failure
      _showAlertDialog('Status', 'Problem Saving Profile');
    }
  }

  void _showAlertDialog(String title, String message) {
    AlertDialog alertDialog = AlertDialog(
      title: Text(title),
      content: Text(message),
    );
    showDialog(context: context, builder: (_) => alertDialog);
  }
}
